#ifndef BARROWINTFLASHADDRS_H
#define BARROWINTFLASHADDRS_H

/*! Sectors reserved for storing settings.*/
#define SETTINGS_SECTOR_1      12
#define SETTINGS_SECTOR_2      13

/*! Sector reserved for custom display images.*/
#define IMAGES_SECTOR          16

/*! Sectors reserved for storing the authorization list. */
#define AUTHLIST_START_SECTOR  17
#define AUTHLIST_NUM_SECTORS   7

/*! Erase all sectors, except the bootloader sector 0,
    and main firmware sectors 5 to 9.*/
#define FACTORY_RESET_SECTORS \
  (const uint32_t[])\
{\
  1,\
  2,\
  3,\
  4,\
  10,\
  11,\
  12,\
  13,\
  14,\
  15,\
  16,\
  17,\
  18,\
  19,\
  20,\
  21,\
  22,\
  23\
}

#define NUM_FACTORY_RESET_SECTORS \
  (sizeof(FACTORY_RESET_SECTORS) / sizeof(FACTORY_RESET_SECTORS[0]))

#endif //BARROWINTFLASHADDRS_H
