#ifndef GPIODESCRIPTIONS_H
#define GPIODESCRIPTIONS_H

#include "gpiopin.h"

#define ST25R3911B_CS_PORT    GPIOE
#define ST25R3911B_CS_PIN     GPIO_Pin_11
#define ST25R3911B_CS         ((const struct SGPIOPin){ST25R3911B_CS_PORT, ST25R3911B_CS_PIN})

#define ST25R3911B_INT_PORT   GPIOE
#define ST25R3911B_INT_PIN    GPIO_Pin_4
#define ST25R3911B_INT        ((const struct SGPIOPin){ST25R3911B_INT_PORT, ST25R3911B_INT_PIN})

#define MODEM_PWRKEY_PORT     GPIOG
#define MODEM_PWRKEY_PIN      GPIO_Pin_5
#define MODEM_PWRKEY          ((const struct SGPIOPin){MODEM_PWRKEY_PORT, MODEM_PWRKEY_PIN})

#define MODEM_STATUS_PORT     GPIOG
#define MODEM_STATUS_PIN      GPIO_Pin_6
#define MODEM_STATUS          ((const struct SGPIOPin){MODEM_STATUS_PORT, MODEM_STATUS_PIN})

#define MODEM_RESET_PORT      GPIOG
#define MODEM_RESET_PIN       GPIO_Pin_7
#define MODEM_RESET           ((const struct SGPIOPin){MODEM_RESET_PORT, MODEM_RESET_PIN})

#define MODEM_SIM_SELECT_PORT GPIOG
#define MODEM_SIM_SELECT_PIN  GPIO_Pin_8
#define MODEM_SIM_SELECT      ((const struct SGPIOPin){MODEM_SIM_SELECT_PORT, MODEM_SIM_SELECT_PIN})

#define P5V0_ENABLE_PORT      GPIOC
#define P5V0_ENABLE_PIN       GPIO_Pin_0
#define P5V0_ENABLE           ((const struct SGPIOPin){P5V0_ENABLE_PORT, P5V0_ENABLE_PIN})

#define P5V0_WARMUP_PORT      GPIOE
#define P5V0_WARMUP_PIN       GPIO_Pin_12
#define P5V0_WARMUP           ((const struct SGPIOPin){P5V0_WARMUP_PORT, P5V0_WARMUP_PIN})

#define BUZZER_PORT           GPIOE
#define BUZZER_PIN            GPIO_Pin_14
#define BUZZER                ((const struct SGPIOPin){BUZZER_PORT, BUZZER_PIN})

#define LCD_PWR_PORT          GPIOF
#define LCD_PWR_PIN           GPIO_Pin_2
#define LCD_PWR               ((const struct SGPIOPin){LCD_PWR_PORT, LCD_PWR_PIN})

#define LCD_BACKLIGHT_PORT    GPIOG
#define LCD_BACKLIGHT_PIN     GPIO_Pin_3
#define LCD_BACKLIGHT         ((const struct SGPIOPin){LCD_BACKLIGHT_PORT, LCD_BACKLIGHT_PIN})

#define LCD_RESET_PORT        GPIOF
#define LCD_RESET_PIN         GPIO_Pin_4
#define LCD_RESET             ((const struct SGPIOPin){LCD_RESET_PORT, LCD_RESET_PIN})

#define RS485_PWR_ON_PORT     GPIOD
#define RS485_PWR_ON_PIN      GPIO_Pin_2
#define RS485_PWR_ON          ((const struct SGPIOPin){RS485_PWR_ON_PORT, RS485_PWR_ON_PIN})

#define RS485_TX_EN_PORT      GPIOB
#define RS485_TX_EN_PIN       GPIO_Pin_8
#define RS485_TX_EN           ((const struct SGPIOPin){RS485_TX_EN_PORT, RS485_TX_EN_PIN})

#define RS485_RX_EN_PORT      GPIOB
#define RS485_RX_EN_PIN       GPIO_Pin_9
#define RS485_RX_EN           ((const struct SGPIOPin){RS485_RX_EN_PORT, RS485_RX_EN_PIN})

#define P12V_SW_PORT          GPIOE
#define P12V_SW_PIN           GPIO_Pin_3
#define P12V_SW               ((const struct SGPIOPin){P12V_SW_PORT, P12V_SW_PIN})

#define P12V_OUT1_PORT        GPIOC
#define P12V_OUT1_PIN         GPIO_Pin_10
#define P12V_OUT1             ((const struct SGPIOPin){P12V_OUT1_PORT, P12V_OUT1_PIN})

#define P12V_OUT2_PORT        GPIOC
#define P12V_OUT2_PIN         GPIO_Pin_11
#define P12V_OUT2             ((const struct SGPIOPin){P12V_OUT2_PORT, P12V_OUT2_PIN})

#define FLASH_WP_PORT         GPIOD
#define FLASH_WP_PIN          GPIO_Pin_8
#define FLASH_WP              ((const struct SGPIOPin){FLASH_WP_PORT, FLASH_WP_PIN})

#define FLASH_HOLD_PORT       GPIOA
#define FLASH_HOLD_PIN        GPIO_Pin_1
#define FLASH_HOLD            ((const struct SGPIOPin){FLASH_HOLD_PORT, FLASH_HOLD_PIN})

#define FLASH_CS_PORT         GPIOA
#define FLASH_CS_PIN          GPIO_Pin_4
#define FLASH_CS              ((const struct SGPIOPin){FLASH_CS_PORT, FLASH_CS_PIN})

#define FLASH_RESET_PORT      GPIOA
#define FLASH_RESET_PIN       GPIO_Pin_8
#define FLASH_RESET           ((const struct SGPIOPin){FLASH_RESET_PORT, FLASH_RESET_PIN})

#define FLASH_ON_PORT         GPIOA
#define FLASH_ON_PIN          GPIO_Pin_11
#define FLASH_ON              ((const struct SGPIOPin){FLASH_ON_PORT, FLASH_ON_PIN})

#define IRDA_SHUTDOWN_PORT    GPIOA
#define IRDA_SHUTDOWN_PIN     GPIO_Pin_12
#define IRDA_SHUTDOWN         ((const struct SGPIOPin){IRDA_SHUTDOWN_PORT, IRDA_SHUTDOWN_PIN})

#define B1_EN_PORT            GPIOC
#define B1_EN_PIN             GPIO_Pin_1
#define B1_EN                 ((const struct SGPIOPin){B1_EN_PORT, B1_EN_PIN})

#define B1_IN1_PORT           GPIOC
#define B1_IN1_PIN            GPIO_Pin_6
#define B1_IN1                ((const struct SGPIOPin){B1_IN1_PORT, B1_IN1_PIN})

#define B1_IN2_PORT           GPIOC
#define B1_IN2_PIN            GPIO_Pin_7
#define B1_IN2                ((const struct SGPIOPin){B1_IN2_PORT, B1_IN2_PIN})

#define B2_EN_PORT            GPIOC
#define B2_EN_PIN             GPIO_Pin_2
#define B2_EN                 ((const struct SGPIOPin){B2_EN_PORT, B2_EN_PIN})

#define B2_IN1_PORT           GPIOC
#define B2_IN1_PIN            GPIO_Pin_8
#define B2_IN1                ((const struct SGPIOPin){B2_IN1_PORT, B2_IN1_PIN})

#define B2_IN2_PORT           GPIOC
#define B2_IN2_PIN            GPIO_Pin_9
#define B2_IN2                ((const struct SGPIOPin){B2_IN2_PORT, B2_IN2_PIN})

#define EN_SB_RAIL_PORT       GPIOC
#define EN_SB_RAIL_PIN        GPIO_Pin_3
#define EN_SB_RAIL            ((const struct SGPIOPin){EN_SB_RAIL_PORT, EN_SB_RAIL_PIN})

#define I2C1_SCL_PORT         GPIOB
#define I2C1_SCL_PIN          GPIO_Pin_6
#define I2C1_SCL              ((const struct SGPIOPin){I2C1_SCL_PORT, I2C1_SCL_PIN})

#define I2C1_SDA_PORT         GPIOB
#define I2C1_SDA_PIN          GPIO_Pin_7
#define I2C1_SDA              ((const struct SGPIOPin){I2C1_SDA_PORT, I2C1_SDA_PIN})

#define I2C2_SCL_PORT         GPIOF
#define I2C2_SCL_PIN          GPIO_Pin_1
#define I2C2_SCL              ((const struct SGPIOPin){I2C2_SCL_PORT, I2C2_SCL_PIN})

#define I2C2_SDA_PORT         GPIOF
#define I2C2_SDA_PIN          GPIO_Pin_0
#define I2C2_SDA              ((const struct SGPIOPin){I2C2_SDA_PORT, I2C2_SDA_PIN})

#define BOOT1_PORT            GPIOB
#define BOOT1_PIN             GPIO_Pin_2
#define BOOT1                 ((const struct SGPIOPin){BOOT1_PORT, BOOT1_PIN})

#define REBOOT_EN_PORT        GPIOB
#define REBOOT_EN_PIN         GPIO_Pin_5
#define REBOOT_EN             ((const struct SGPIOPin){REBOOT_EN_PORT, REBOOT_EN_PIN})

#define SENSOR_CS_PORT        GPIOB
#define SENSOR_CS_PIN         GPIO_Pin_15
#define SENSOR_CS             ((const struct SGPIOPin){SENSOR_CS_PORT, SENSOR_CS_PIN})

#define SENSOR_INT2_PORT      GPIOB
#define SENSOR_INT2_PIN       GPIO_Pin_14
#define SENSOR_INT2           ((const struct SGPIOPin){SENSOR_INT2_PORT, SENSOR_INT2_PIN})

#define SENSOR_PRESENT_PORT   GPIOB
#define SENSOR_PRESENT_PIN    GPIO_Pin_13
#define SENSOR_PRESENT        ((const struct SGPIOPin){SENSOR_PRESENT_PORT, SENSOR_PRESENT_PIN})

#define ADC12_14_OPT2_PORT    GPIOC
#define ADC12_14_OPT2_PIN     GPIO_Pin_4
#define ADC12_14_OPT2         ((const struct SGPIOPin){ADC12_14_OPT2_PORT, ADC12_14_OPT2_PIN})

#endif //GPIODESCRIPTIONS_H
