#ifndef LOGLEVELS_H
#define LOGLEVELS_H

//Application log levels are defined here

#define LOGREADER     0
#define LOGSERVERCOMM 1
#define LOGLOCK       2
#define LOGDISPLAY    3
#define LOGDEPOSIT    4
#define LOGUSRINTRFCE 5
#define LOGINPUTS     6
#define LOGREG        7
#define LOGSETTINGS   8
#define LOGINPUTMNTR  9
#define LOGAUTHLIST   10
#define LOGLOWPOWER   11
#define LOGSTATUS     12
#define LOGCONTROLLER 13
#define LOGPREPAID    14
#define LOGIMAGES     15
#define LOGSELFTEST   16
#define LOGFACTORYRST 17
#define LOGACTIVE     18
#define LOGDEPOSITTMR 19
#define LOG6DSENSOR   20
#define LOGPCBVERSION 21

/*! Compound literal array that is used as argument to SetApplicationLogLevels from main(),
    each array entry should correspond to one of the defines above.*/
#define LOGLEVELS \
(const char* const[]) \
{ \
  "READER", \
  "SERVERCOMM", \
  "LOCK",\
  "DISPLAY",\
  "DEPOSIT",\
  "USRINTRFCE", \
  "INPUTS", \
  "REG", \
  "SETTINGS", \
  "INPUTMNTR", \
  "AUTHLIST", \
  "LOWPOWER", \
  "STATUS", \
  "CONTROLLER", \
  "PREPAID", \
  "IMAGES", \
  "SELFTEST", \
  "FACTORYRST", \
  "ACTIVE", \
  "DEPOSITTMR", \
  "6DSENSOR", \
  "PCBVERSION", \
}

#endif //LOGLEVELS_H
