#ifndef LOWPOWERSCHEDULER_H
#define LOWPOWERSCHEDULER_H

#include "rtcscheduler.h"
#include "lowpower.h"

/*! RTC scheduler with the addition that it blocks entering low power mode when
    the scheduler is performing tasks, and that it allows entering low power
    mode when the scheduler is waiting for an alarm.*/
class CLowPowerScheduler : public CRTCScheduler, public CLowPowerTask
{
  public:
    CLowPowerScheduler();

  private:
    virtual void PostSetup();
    virtual void PreProcess();
    virtual void PostProcess();
};

#endif //LOWPOWERSCHEDULER_H
