#ifndef STATUSVALUES_H
#define STATUSVALUES_H

enum EStatus
{
  Status_ExternalBatteryVoltageNoLoad    = 0,
  Status_ExternalBatteryVoltageUnderLoad = 1,
  Status_FillLevel                       = 2,
  Status_SoftwareVersion                 = 3,
  Status_FillLevelSensor                 = 4,
  Status_PWRVoltageNoLoad                = 5,
  Status_PWRVoltageUnderLoad             = 6,
  Status_Emptied                         = 8,
  Status_NrContactAttempts               = 9,
  Status_BatteryState                    = 11,
  Status_SoftReset                       = 12,
  Status_PowerOnNoTag                    = 52,
  Status_ModemRSSI                       = 53,
  Status_ExternalSIMICCID                = 54,
  Status_ContactReason                   = 55,
  Status_Opened                          = 56,
  Status_NotOpened                       = 57,
  Status_Refused                         = 58,
  Status_InCorrectAuthListEntry          = 59,
  Status_AuthListTooLarge                = 60,
  Status_Debug                           = 62,
  Status_FunctionTag                     = 63,
  Status_FillLevelUltraSonic2            = 64,
  Status_FillLevelUltraSonic3            = 65,
  Status_InternalBatteryVoltageNoLoad    = 66,
  Status_InternalBatteryVoltageUnderLoad = 67,
  Status_InternalSIMICCID                = 68,
  Status_GrafixError                     = 69,
  Status_Temperature                     = 70,
  Status_DepositOpeningStayedOpen        = 71,
  Status_InternalBatteryChargeCurrent    = 72,
  Status_SolarVoltage                    = 73,
  Status_GPSLocation                     = 74,
  Status_HardwareError                   = 75,
  Status_ConnectedCell                   = 76,
  Status_FactoryReset                    = 77,
  Status_MadeActive                      = 78,
  Status_SelfTestPassed                  = 79,
  Status_CableTestPassed                 = 80,
  Status_ModemType                       = 81,
  Status_RegistrationSwitchError         = 82,
  Status_DepositRefused                  = 83,
  Status_DoorStayedOpen                  = 84,
  Status_AccelerationDetect              = 85,
  Status_RotationDetect                  = 86,
  Status_PCBVersion                      = 87,
  Status_IpAlmere                        = 100,
  Status_RestartAlmere                   = 101,
  Status_DepositOpeningOpened            = 102,
  Status_DepositOpeningBlocked           = 103,
  Status_IsAlive                         = 104,
  Status_ApplicationErrorAlmere          = 105,
};

const char* StatusToStr(EStatus status);

#endif //STATUSVALUES_H
