#include "errorcode.h"
#include <cstddef>

const char* ErrorCodeStr(ErrorCode errorcode)
{
  static const char* errorcodestrs[] =
  {
    "none",
    "UID not authorized",
    "battery voltage too low",
    "outside TimeOpen/TimeClose settings",
    "inside BlockStart/BlockStop settings",
    "maximum fill level reached",
    "container already opened",
    "not enough prepaid credit",
    "wrong lock type set",
    "container not opened",
    "NFC reader error",
    "card functionality not implemented",
    "card not authenticated",
    "can't program card",
  };

  std::size_t index = (size_t)errorcode;
  if (index >= 0 && index < sizeof(errorcodestrs) / sizeof(errorcodestrs[0]))
    return errorcodestrs[index];
  else
    return "ERROR UNKNOWN ERROR CODE";
}
