#include "gpio.h"

/*! Describes the initialization state of every GPIO, used in GPIOInit().*/
extern const SGPIOStateInit PortInit[NUM_PORTS][PINS_PER_PORT] =
{
  {//Port A
    {LOW,  { GPIO_Pin_0,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PA0  WAKEUP
    {LOW,  { GPIO_Pin_1,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PA1  SPI1_FLASH_SIO3/HOLD#
    {LOW,  { GPIO_Pin_2,  GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_UP     }, GPIO_AF_USART2 }, //PA2  USART2_IRDA_RX
    {HIGH, { GPIO_Pin_3,  GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_USART2 }, //PA3  USART2_IRDA_TX
    {LOW,  { GPIO_Pin_4,  GPIO_Mode_OUT, GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PA4  !SPI1_FLASH_CS
    {LOW,  { GPIO_Pin_5,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_SPI1   }, //PA5  SPI1_FLASH_SCK
    {LOW,  { GPIO_Pin_6,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_SPI1   }, //PA6  SPI1_FLASH_MISO
    {LOW,  { GPIO_Pin_7,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_SPI1   }, //PA7  SPI1_FLASH_MOSI
    {LOW,  { GPIO_Pin_8,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PA8  !GPIO_FLASH_RESET
    {HIGH, { GPIO_Pin_9,  GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_USART1 }, //PA9  USART1_ISP_TX
    {LOW,  { GPIO_Pin_10, GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_UP     }, GPIO_AF_USART1 }, //PA10 USART1_ISP_RX
    {HIGH, { GPIO_Pin_11, GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PA11 FLASH_ON
    {HIGH, { GPIO_Pin_12, GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PA12 IRDA_SHUTDOWN
    {LOW,  { 0          , GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_SWJ    }, //PA13 JTAG TMS SWDIO #Initializing JTAG
    {LOW,  { 0          , GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_SWJ    }, //PA14 JTAG TCK SWCLK #pins causes problems
    {LOW,  { 0          , GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_SWJ    }, //PA15 JTAG TDI       #with the debugger.
  },
  {//Port B
    {LOW,  { GPIO_Pin_0,  GPIO_Mode_AN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PB0  ADC12_8_VRAIL
    {HIGH, { GPIO_Pin_1,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PB1  IC5_RESET (since PCB 1.6)
    {LOW,  { GPIO_Pin_2,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PB2  BOOT1
    {LOW,  { 0         ,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_SWJ    }, //PB3  JTAG TDO SWO
    {LOW,  { 0         ,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_SWJ    }, //PB4  JTAG TRST
    {HIGH, { GPIO_Pin_5,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PB5  !REBOOT_EN
    {HIGH, { GPIO_Pin_6,  GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_OD, GPIO_PuPd_UP     }, GPIO_AF_I2C1   }, //PB6  I2C1_RTC_SCL
    {HIGH, { GPIO_Pin_7,  GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_OD, GPIO_PuPd_UP     }, GPIO_AF_I2C1   }, //PB7  I2C1_RTC_SDA
    {LOW,  { GPIO_Pin_8,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PB8  GPIO_485_TX_EN
    {HIGH, { GPIO_Pin_9,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PB9  !GPIO_485_RX_EN
    {LOW,  { GPIO_Pin_10, GPIO_Mode_AF,  GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_USART3 }, //PB10 USART3_485_TXD
    {LOW,  { GPIO_Pin_11, GPIO_Mode_AF,  GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_UP     }, GPIO_AF_USART3 }, //PB11 USART3_485_RXD
    {LOW,  { GPIO_Pin_12, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PB12 T2_CAP3_RFID125
    {LOW,  { GPIO_Pin_13, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PB13 T2_CAP1_RFID125 / SENSOR_PRESENT
    {LOW,  { GPIO_Pin_14, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PB14 GPIO_SHD_RFID125 / SENSOR_INT2
    {HIGH, { GPIO_Pin_15, GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PB15 T2_MATO_RFID125 / SENSOR_CS
  },
  {//Port C
    {LOW,  { GPIO_Pin_0,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PC0  5V0_ENABLE
    {LOW,  { GPIO_Pin_1,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PC1  B1_EN
    {LOW,  { GPIO_Pin_2,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PC2  B2_EN
    {LOW,  { GPIO_Pin_3,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PC3  EN_SB_RAIL
    {LOW,  { GPIO_Pin_4,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PC4  ADC12_14_OPT2
    {LOW,  { GPIO_Pin_5,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PC5  ADC12_15_OPT1
    {LOW,  { GPIO_Pin_6,  GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_TIM8   }, //PC6  B1_IN1
    {LOW,  { GPIO_Pin_7,  GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_TIM8   }, //PC7  B1_IN2
    {LOW,  { GPIO_Pin_8,  GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_TIM8   }, //PC8  B2_IN1
    {LOW,  { GPIO_Pin_9,  GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_TIM8   }, //PC9  B2_IN2
    {LOW,  { GPIO_Pin_10, GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PC10 OUT1
    {LOW,  { GPIO_Pin_11, GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PC11 OUT2
    {HIGH, { GPIO_Pin_12, GPIO_Mode_AF,  GPIO_Speed_25MHz,  GPIO_OType_OD, GPIO_PuPd_UP     }, GPIO_AF_I2C1   }, //PC12 !SMBALERT
    {LOW,  { GPIO_Pin_13, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PC13
    {LOW,  { GPIO_Pin_14, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PC14 32 kHz oscillator input
    {LOW,  { GPIO_Pin_15, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PC15 32 kHz oscillator output
  },
  {//Port D
    {LOW,  { GPIO_Pin_0,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_FMC    }, //PD0  LCD_D2
    {LOW,  { GPIO_Pin_1,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_FMC    }, //PD1  LCD_D3
    {LOW,  { GPIO_Pin_2,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PD2  RS485_PWR_ON
    {LOW,  { GPIO_Pin_3,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PD3
    {LOW,  { GPIO_Pin_4,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_FMC    }, //PD4  LCD_E
    {LOW,  { GPIO_Pin_5,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_FMC    }, //PD5  LCD_R/W
    {LOW,  { GPIO_Pin_6,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PD6
    {LOW,  { GPIO_Pin_7,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_FMC    }, //PD7  LCD_CSB
    {LOW,  { GPIO_Pin_8,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PD8  SPI1_FLASH_SIO2/WP#
    {LOW,  { GPIO_Pin_9,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PD9  TP7
    {LOW,  { GPIO_Pin_10, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PD10 TP6
    {LOW,  { GPIO_Pin_11, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PD11 TP5
    {LOW,  { GPIO_Pin_12, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PD12 TP2
    {LOW,  { GPIO_Pin_13, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PD13 TP1
    {LOW,  { GPIO_Pin_14, GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_FMC    }, //PD14 LCD_D0
    {LOW,  { GPIO_Pin_15, GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_FMC    }, //PD15 LCD_D1
  },
  {//Port E
    {LOW,  { GPIO_Pin_0,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PE0  RX8
    {LOW,  { GPIO_Pin_1,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PE1  TX8
    {LOW,  { GPIO_Pin_2,  GPIO_Mode_OUT,  GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_NOPULL /*edwin*/   }, -1 /* GPIO_AF_SPI4 */  }, //PE2  ST25R3911B SCK
    {LOW,  { GPIO_Pin_3,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PE3  12V_SW
    {LOW,  { GPIO_Pin_4,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_OD /*edwin*/, GPIO_PuPd_NOPULL /*edwin*/   }, -1             }, //PE4  ST25R3911B IRQ
    {LOW,  { GPIO_Pin_5,  GPIO_Mode_IN,  GPIO_Speed_100MHz,  GPIO_OType_OD /*edwin*/, GPIO_PuPd_NOPULL /*edwin*/   }, -1 /*GPIO_AF_SPI4*/   }, //PE5  ST25R3911B MISO
    {LOW,  { GPIO_Pin_6,  GPIO_Mode_OUT,  GPIO_Speed_100MHz,  GPIO_OType_PP, GPIO_PuPd_NOPULL  /*edwin*/ }, -1 /* GPIO_AF_SPI4  */ }, //PE6  ST25R3911B MOSI
    {LOW,  { GPIO_Pin_7,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_FMC    }, //PE7  LCD_D4 / RX7
    {LOW,  { GPIO_Pin_8,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_FMC    }, //PE8  LCD_D5 / TX7
    {LOW,  { GPIO_Pin_9,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_FMC    }, //PE9  LCD_D6
    {LOW,  { GPIO_Pin_10, GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_FMC    }, //PE10 LCD_D7
    {HIGH, { GPIO_Pin_11, GPIO_Mode_OUT, GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PE11 ST25R3911B CS
    {LOW,  { GPIO_Pin_12, GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PE12 5V0_WARMUP (since PCB 1.6)
    {LOW,  { GPIO_Pin_13, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PE13
    {LOW,  { GPIO_Pin_14, GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_TIM1   }, //PE14 BUZZER
    {LOW,  { GPIO_Pin_15, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_UP     }, -1             }, //PE15 INT_RTC_EXT
  },
  {//Port F
    {HIGH, { GPIO_Pin_0,  GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_OD, GPIO_PuPd_UP     }, GPIO_AF_I2C2   }, //PF0  I2C2_SDA
    {HIGH, { GPIO_Pin_1,  GPIO_Mode_AF,  GPIO_Speed_2MHz,   GPIO_OType_OD, GPIO_PuPd_UP     }, GPIO_AF_I2C2   }, //PF1  I2C2_SCL
    {LOW,  { GPIO_Pin_2,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PF2  LCD_PWR
    {LOW,  { GPIO_Pin_3,  GPIO_Mode_AF,  GPIO_Speed_100MHz, GPIO_OType_PP, GPIO_PuPd_NOPULL }, GPIO_AF_FMC    }, //PF3  LCD_RS
    {LOW,  { GPIO_Pin_4,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PF4  LCD_RESET
    {LOW,  { GPIO_Pin_5,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PF5  MODEM_PSM_IND
    {LOW,  { GPIO_Pin_6,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PF6
    {LOW,  { GPIO_Pin_7,  GPIO_Mode_AF,  GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_UP     }, GPIO_AF_SPI5   }, //PF7  GUI_SCK5
    {LOW,  { GPIO_Pin_8,  GPIO_Mode_AF,  GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_UP     }, GPIO_AF_SPI5   }, //PF8  GUI_MISO5
    {LOW,  { GPIO_Pin_9,  GPIO_Mode_AF,  GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_UP     }, GPIO_AF_SPI5   }, //PF9  GUI_MOSI5
    {LOW,  { GPIO_Pin_10, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PF10
    {LOW,  { GPIO_Pin_11, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PF11
    {LOW,  { GPIO_Pin_12, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PF12
    {LOW,  { GPIO_Pin_13, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PF13
    {LOW,  { GPIO_Pin_14, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PF14
    {LOW,  { GPIO_Pin_15, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PF15
  },
  {//Port G
    {LOW,  { GPIO_Pin_0,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PG0
    {LOW,  { GPIO_Pin_1,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PG1
    {LOW,  { GPIO_Pin_2,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PG2
    {LOW,  { GPIO_Pin_3,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PG3  LCD_BACKLIGHT_EN
    {LOW,  { GPIO_Pin_4,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PG4  MODEM_COM_DISABLE
    {LOW,  { GPIO_Pin_5,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PG5  MODEM_ON/OFF
    {LOW,  { GPIO_Pin_6,  GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_UP     }, -1             }, //PG6  MODEM_STATUS
    {LOW,  { GPIO_Pin_7,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PG7  MODEM_RESET
    {LOW,  { GPIO_Pin_8,  GPIO_Mode_OUT, GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_NOPULL }, -1             }, //PG8  MODEM_SIM_SELECT
    {LOW,  { GPIO_Pin_9,  GPIO_Mode_AF,  GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_UP     }, GPIO_AF_USART6 }, //PG9  MCU RX,  Modem TX
    {LOW,  { GPIO_Pin_10, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PG10 MCU RI,  Modem RI
    {LOW,  { GPIO_Pin_11, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PG11 MCU DTR, Modem DCD
    {LOW,  { GPIO_Pin_12, GPIO_Mode_AF,  GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_USART6 }, //PG12 MCU RTS, Modem CTS
    {LOW,  { GPIO_Pin_13, GPIO_Mode_AF,  GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_DOWN   }, GPIO_AF_USART6 }, //PG13 MCU CTS, Modem RTS
    {HIGH, { GPIO_Pin_14, GPIO_Mode_AF,  GPIO_Speed_25MHz,  GPIO_OType_PP, GPIO_PuPd_UP     }, GPIO_AF_USART6 }, //PG14 MCU TX,  Modem RX
    {LOW,  { GPIO_Pin_15, GPIO_Mode_IN,  GPIO_Speed_2MHz,   GPIO_OType_PP, GPIO_PuPd_DOWN   }, -1             }, //PG15 MCU DCD, Modem DTR
  },
};
