#include "lowpowerscheduler.h"

CLowPowerScheduler::CLowPowerScheduler()
{
}

/*! Called from CRTCScheduler::Setup().*/
void CLowPowerScheduler::PostSetup()
{
  RegisterLowPowerTask("rtcscheduler");
}

/*! Called from CRTCScheduler::Process() before scheduled entries are processed.*/
void CLowPowerScheduler::PreProcess()
{
  //Don't allow entering low power mode while processing scheduled entries.
  AllowLowPower(false);
}

/*! Called from CRTCScheduler::Process() after scheduled entries are processed
    and the RTC alarm has been enabled.*/
void CLowPowerScheduler::PostProcess()
{
  //Allow entering low power mode when scheduled entries are processed.
  AllowLowPower(true);
}
