#include "lvgl.h"

/*******************************************************************************
 * Size: 16 px
 * Bpp: 1
 * Opts: 
 ******************************************************************************/

// This is the CP437 font from https://cp437.github.io/
// converted using https://littlevgl.com/ttf-font-to-c-array

#ifndef LV_FONT_CP437
#define LV_FONT_CP437 1
#endif

#if LV_FONT_CP437

/*-----------------
 *    BITMAPS
 *----------------*/

/*Store the image of the glyphs*/
static LV_ATTRIBUTE_LARGE_CONST const uint8_t gylph_bitmap[] = {
    /* U+20 " " */
    0x0,

    /* U+21 "!" */
    0x6f, 0xff, 0x66, 0x60, 0x66,

    /* U+22 "\"" */
    0xcf, 0x3c, 0xd2,

    /* U+23 "#" */
    0x6c, 0xdb, 0xfb, 0x66, 0xcd, 0xbf, 0xb6, 0x6c,

    /* U+24 "$" */
    0x18, 0x31, 0xf6, 0x3c, 0x38, 0x1f, 0x3, 0x7,
    0xf, 0x1b, 0xe1, 0x83, 0x0,

    /* U+25 "%" */
    0xc3, 0x8c, 0x30, 0xc3, 0xc, 0x31, 0xc3,

    /* U+26 "&" */
    0x38, 0xd9, 0xb1, 0xc7, 0x7b, 0xb3, 0x66, 0xcc,
    0xec,

    /* U+27 "'" */
    0x6d, 0xe0,

    /* U+28 "(" */
    0x36, 0xcc, 0xcc, 0xcc, 0x63,

    /* U+29 ")" */
    0xc6, 0x33, 0x33, 0x33, 0x6c,

    /* U+2A "*" */
    0x66, 0x3c, 0xff, 0x3c, 0x66,

    /* U+2B "+" */
    0x30, 0xcf, 0xcc, 0x30,

    /* U+2C "," */
    0x6d, 0xe0,

    /* U+2D "-" */
    0xfe,

    /* U+2E "." */
    0xf0,

    /* U+2F "/" */
    0x2, 0xc, 0x30, 0xc3, 0xc, 0x30, 0x40,

    /* U+30 "0" */
    0x38, 0xdb, 0x1e, 0x3d, 0x7a, 0xf1, 0xe3, 0x6c,
    0x70,

    /* U+31 "1" */
    0x31, 0xcf, 0xc, 0x30, 0xc3, 0xc, 0x33, 0xf0,

    /* U+32 "2" */
    0x7d, 0x8c, 0x18, 0x61, 0x86, 0x18, 0x60, 0xc7,
    0xfc,

    /* U+33 "3" */
    0x7d, 0x8c, 0x18, 0x33, 0xc0, 0xc1, 0x83, 0xc6,
    0xf8,

    /* U+34 "4" */
    0xc, 0x38, 0xf3, 0x6c, 0xdf, 0xc3, 0x6, 0xc,
    0x3c,

    /* U+35 "5" */
    0xff, 0x83, 0x6, 0xf, 0xc0, 0xc1, 0x83, 0xc6,
    0xf8,

    /* U+36 "6" */
    0x38, 0xc3, 0x6, 0xf, 0xd8, 0xf1, 0xe3, 0xc6,
    0xf8,

    /* U+37 "7" */
    0xff, 0x8c, 0x18, 0x30, 0xc3, 0xc, 0x18, 0x30,
    0x60,

    /* U+38 "8" */
    0x7d, 0x8f, 0x1e, 0x37, 0xd8, 0xf1, 0xe3, 0xc6,
    0xf8,

    /* U+39 "9" */
    0x7d, 0x8f, 0x1e, 0x37, 0xe0, 0xc1, 0x83, 0xc,
    0xf0,

    /* U+3A ":" */
    0xf0, 0x3c,

    /* U+3B ";" */
    0x6c, 0x0, 0xde,

    /* U+3C "<" */
    0xc, 0x63, 0x18, 0xc1, 0x83, 0x6, 0xc,

    /* U+3D "=" */
    0xfc, 0x0, 0x3f,

    /* U+3E ">" */
    0xc1, 0x83, 0x6, 0xc, 0x63, 0x18, 0xc0,

    /* U+3F "?" */
    0x7d, 0x8f, 0x18, 0x61, 0x83, 0x6, 0x0, 0x18,
    0x30,

    /* U+40 "@" */
    0x7d, 0x8f, 0x1e, 0xfd, 0xfb, 0xf7, 0x60, 0x7c,

    /* U+41 "A" */
    0x10, 0x71, 0xb6, 0x3c, 0x7f, 0xf1, 0xe3, 0xc7,
    0x8c,

    /* U+42 "B" */
    0xfc, 0xcd, 0x9b, 0x37, 0xcc, 0xd9, 0xb3, 0x67,
    0xf8,

    /* U+43 "C" */
    0x3c, 0xcf, 0xe, 0xc, 0x18, 0x30, 0x61, 0x66,
    0x78,

    /* U+44 "D" */
    0xf8, 0xd9, 0x9b, 0x36, 0x6c, 0xd9, 0xb3, 0x6d,
    0xf0,

    /* U+45 "E" */
    0xfe, 0xcd, 0x8b, 0x47, 0x8d, 0x18, 0x31, 0x67,
    0xfc,

    /* U+46 "F" */
    0xfe, 0xcd, 0x8b, 0x47, 0x8d, 0x18, 0x30, 0x61,
    0xe0,

    /* U+47 "G" */
    0x3c, 0xcf, 0xe, 0xc, 0x1b, 0xf1, 0xe3, 0x66,
    0x74,

    /* U+48 "H" */
    0xc7, 0x8f, 0x1e, 0x3f, 0xf8, 0xf1, 0xe3, 0xc7,
    0x8c,

    /* U+49 "I" */
    0xf6, 0x66, 0x66, 0x66, 0x6f,

    /* U+4A "J" */
    0x1e, 0x18, 0x30, 0x60, 0xc1, 0xb3, 0x66, 0xcc,
    0xf0,

    /* U+4B "K" */
    0xe6, 0xcd, 0x9b, 0x67, 0x8f, 0x1b, 0x33, 0x67,
    0xcc,

    /* U+4C "L" */
    0xf0, 0xc1, 0x83, 0x6, 0xc, 0x18, 0x31, 0x67,
    0xfc,

    /* U+4D "M" */
    0xc7, 0xdf, 0xff, 0xfd, 0x78, 0xf1, 0xe3, 0xc7,
    0x8c,

    /* U+4E "N" */
    0xc7, 0xcf, 0xdf, 0xfd, 0xf9, 0xf1, 0xe3, 0xc7,
    0x8c,

    /* U+4F "O" */
    0x7d, 0x8f, 0x1e, 0x3c, 0x78, 0xf1, 0xe3, 0xc6,
    0xf8,

    /* U+50 "P" */
    0xfc, 0xcd, 0x9b, 0x37, 0xcc, 0x18, 0x30, 0x61,
    0xe0,

    /* U+51 "Q" */
    0x7d, 0x8f, 0x1e, 0x3c, 0x78, 0xf1, 0xeb, 0xde,
    0xf8, 0x30, 0x70,

    /* U+52 "R" */
    0xfc, 0xcd, 0x9b, 0x37, 0xcd, 0x99, 0xb3, 0x67,
    0xcc,

    /* U+53 "S" */
    0x7d, 0x8f, 0x1b, 0x3, 0x81, 0x81, 0xe3, 0xc6,
    0xf8,

    /* U+54 "T" */
    0xff, 0xfb, 0x4c, 0x30, 0xc3, 0xc, 0x31, 0xe0,

    /* U+55 "U" */
    0xc7, 0x8f, 0x1e, 0x3c, 0x78, 0xf1, 0xe3, 0xc6,
    0xf8,

    /* U+56 "V" */
    0xc7, 0x8f, 0x1e, 0x3c, 0x78, 0xf1, 0xb6, 0x38,
    0x20,

    /* U+57 "W" */
    0xc7, 0x8f, 0x1e, 0x3d, 0x7a, 0xf5, 0xff, 0xee,
    0xd8,

    /* U+58 "X" */
    0xc7, 0x8d, 0xb3, 0xe3, 0x87, 0x1f, 0x36, 0xc7,
    0x8c,

    /* U+59 "Y" */
    0xcf, 0x3c, 0xf3, 0x78, 0xc3, 0xc, 0x31, 0xe0,

    /* U+5A "Z" */
    0xff, 0x8e, 0x18, 0x61, 0x86, 0x18, 0x61, 0xc7,
    0xfc,

    /* U+5B "[" */
    0xfc, 0xcc, 0xcc, 0xcc, 0xcf,

    /* U+5C "\\" */
    0x81, 0x83, 0x83, 0x83, 0x83, 0x83, 0x83, 0x2,

    /* U+5D "]" */
    0xf3, 0x33, 0x33, 0x33, 0x3f,

    /* U+5E "^" */
    0x10, 0x71, 0xb6, 0x30,

    /* U+5F "_" */
    0xff,

    /* U+60 "`" */
    0xc6, 0x30,

    /* U+61 "a" */
    0x78, 0x19, 0xf6, 0x6c, 0xd9, 0x9d, 0x80,

    /* U+62 "b" */
    0xe0, 0xc1, 0x83, 0xc6, 0xcc, 0xd9, 0xb3, 0x66,
    0xf8,

    /* U+63 "c" */
    0x7d, 0x8f, 0x6, 0xc, 0x18, 0xdf, 0x0,

    /* U+64 "d" */
    0x1c, 0x18, 0x31, 0xe6, 0xd9, 0xb3, 0x66, 0xcc,
    0xec,

    /* U+65 "e" */
    0x7d, 0x8f, 0xfe, 0xc, 0x18, 0xdf, 0x0,

    /* U+66 "f" */
    0x39, 0xb6, 0x58, 0xf1, 0x86, 0x18, 0x63, 0xc0,

    /* U+67 "g" */
    0x77, 0x9b, 0x36, 0x6c, 0xd9, 0x9f, 0x6, 0xcc,
    0xf0,

    /* U+68 "h" */
    0xe0, 0xc1, 0x83, 0x67, 0x6c, 0xd9, 0xb3, 0x67,
    0xcc,

    /* U+69 "i" */
    0x66, 0xe, 0x66, 0x66, 0x6f,

    /* U+6A "j" */
    0xc, 0x30, 0x7, 0xc, 0x30, 0xc3, 0xc, 0x3c,
    0xf3, 0x78,

    /* U+6B "k" */
    0xe0, 0xc1, 0x83, 0x36, 0xcf, 0x1e, 0x36, 0x67,
    0xcc,

    /* U+6C "l" */
    0xe6, 0x66, 0x66, 0x66, 0x6f,

    /* U+6D "m" */
    0xed, 0xff, 0x5e, 0xbd, 0x7a, 0xf1, 0x80,

    /* U+6E "n" */
    0xdc, 0xcd, 0x9b, 0x36, 0x6c, 0xd9, 0x80,

    /* U+6F "o" */
    0x7d, 0x8f, 0x1e, 0x3c, 0x78, 0xdf, 0x0,

    /* U+70 "p" */
    0xdc, 0xcd, 0x9b, 0x36, 0x6c, 0xdf, 0x30, 0x61,
    0xe0,

    /* U+71 "q" */
    0x77, 0x9b, 0x36, 0x6c, 0xd9, 0x9f, 0x6, 0xc,
    0x3c,

    /* U+72 "r" */
    0xdc, 0xed, 0x9b, 0x6, 0xc, 0x3c, 0x0,

    /* U+73 "s" */
    0x7d, 0x8d, 0x81, 0xc0, 0xd8, 0xdf, 0x0,

    /* U+74 "t" */
    0x10, 0x60, 0xc7, 0xe3, 0x6, 0xc, 0x18, 0x36,
    0x38,

    /* U+75 "u" */
    0xcd, 0x9b, 0x36, 0x6c, 0xd9, 0x9d, 0x80,

    /* U+76 "v" */
    0xc7, 0x8f, 0x1e, 0x3c, 0x6d, 0x8e, 0x0,

    /* U+77 "w" */
    0xc7, 0x8f, 0x5e, 0xbd, 0x7f, 0xdb, 0x0,

    /* U+78 "x" */
    0xc6, 0xd8, 0xe1, 0xc3, 0x8d, 0xb1, 0x80,

    /* U+79 "y" */
    0xc7, 0x8f, 0x1e, 0x3c, 0x78, 0xdf, 0x83, 0xd,
    0xf0,

    /* U+7A "z" */
    0xff, 0x98, 0x61, 0x86, 0x18, 0xff, 0x80,

    /* U+7B "{" */
    0x1c, 0xc3, 0xc, 0xe0, 0xc3, 0xc, 0x30, 0x70,

    /* U+7C "|" */
    0xff, 0xff, 0xf0,

    /* U+7D "}" */
    0xe0, 0xc3, 0xc, 0x1c, 0xc3, 0xc, 0x33, 0x80,

    /* U+7E "~" */
    0x77, 0xb8,

    /* U+7F "" */
    0x10, 0x71, 0xb6, 0x3c, 0x78, 0xff, 0x80
};


/*---------------------
 *  GLYPH DESCRIPTION
 *--------------------*/

static const lv_font_fmt_txt_glyph_dsc_t glyph_dsc[] = {
    {.bitmap_index = 0, .adv_w = 0, .box_w = 0, .box_h = 0, .ofs_x = 0, .ofs_y = 0} /* id = 0 reserved */,
    {.bitmap_index = 0, .adv_w = 144, .box_w = 1, .box_h = 1, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 1, .adv_w = 144, .box_w = 4, .box_h = 10, .ofs_x = 2, .ofs_y = 0},
    {.bitmap_index = 6, .adv_w = 144, .box_w = 6, .box_h = 4, .ofs_x = 1, .ofs_y = 7},
    {.bitmap_index = 9, .adv_w = 144, .box_w = 7, .box_h = 9, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 17, .adv_w = 144, .box_w = 7, .box_h = 14, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 30, .adv_w = 144, .box_w = 7, .box_h = 8, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 37, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 46, .adv_w = 144, .box_w = 3, .box_h = 4, .ofs_x = 1, .ofs_y = 7},
    {.bitmap_index = 48, .adv_w = 144, .box_w = 4, .box_h = 10, .ofs_x = 2, .ofs_y = 0},
    {.bitmap_index = 53, .adv_w = 144, .box_w = 4, .box_h = 10, .ofs_x = 2, .ofs_y = 0},
    {.bitmap_index = 58, .adv_w = 144, .box_w = 8, .box_h = 5, .ofs_x = 0, .ofs_y = 2},
    {.bitmap_index = 63, .adv_w = 144, .box_w = 6, .box_h = 5, .ofs_x = 1, .ofs_y = 2},
    {.bitmap_index = 67, .adv_w = 144, .box_w = 3, .box_h = 4, .ofs_x = 2, .ofs_y = -1},
    {.bitmap_index = 69, .adv_w = 144, .box_w = 7, .box_h = 1, .ofs_x = 0, .ofs_y = 4},
    {.bitmap_index = 70, .adv_w = 144, .box_w = 2, .box_h = 2, .ofs_x = 3, .ofs_y = 0},
    {.bitmap_index = 71, .adv_w = 144, .box_w = 7, .box_h = 8, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 78, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 87, .adv_w = 144, .box_w = 6, .box_h = 10, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 95, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 104, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 113, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 122, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 131, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 140, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 149, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 158, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 167, .adv_w = 144, .box_w = 2, .box_h = 7, .ofs_x = 3, .ofs_y = 1},
    {.bitmap_index = 169, .adv_w = 144, .box_w = 3, .box_h = 8, .ofs_x = 2, .ofs_y = 0},
    {.bitmap_index = 172, .adv_w = 144, .box_w = 6, .box_h = 9, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 179, .adv_w = 144, .box_w = 6, .box_h = 4, .ofs_x = 1, .ofs_y = 3},
    {.bitmap_index = 182, .adv_w = 144, .box_w = 6, .box_h = 9, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 189, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 198, .adv_w = 144, .box_w = 7, .box_h = 9, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 206, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 215, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 224, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 233, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 242, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 251, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 260, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 269, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 278, .adv_w = 144, .box_w = 4, .box_h = 10, .ofs_x = 2, .ofs_y = 0},
    {.bitmap_index = 283, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 292, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 301, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 310, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 319, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 328, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 337, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 346, .adv_w = 144, .box_w = 7, .box_h = 12, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 357, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 366, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 375, .adv_w = 144, .box_w = 6, .box_h = 10, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 383, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 392, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 401, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 410, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 419, .adv_w = 144, .box_w = 6, .box_h = 10, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 427, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 436, .adv_w = 144, .box_w = 4, .box_h = 10, .ofs_x = 2, .ofs_y = 0},
    {.bitmap_index = 441, .adv_w = 144, .box_w = 7, .box_h = 9, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 449, .adv_w = 144, .box_w = 4, .box_h = 10, .ofs_x = 2, .ofs_y = 0},
    {.bitmap_index = 454, .adv_w = 144, .box_w = 7, .box_h = 4, .ofs_x = 0, .ofs_y = 8},
    {.bitmap_index = 458, .adv_w = 144, .box_w = 8, .box_h = 1, .ofs_x = 0, .ofs_y = -2},
    {.bitmap_index = 459, .adv_w = 144, .box_w = 4, .box_h = 3, .ofs_x = 2, .ofs_y = 8},
    {.bitmap_index = 461, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 468, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 477, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 484, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 493, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 500, .adv_w = 144, .box_w = 6, .box_h = 10, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 508, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 517, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 526, .adv_w = 144, .box_w = 4, .box_h = 10, .ofs_x = 2, .ofs_y = 0},
    {.bitmap_index = 531, .adv_w = 144, .box_w = 6, .box_h = 13, .ofs_x = 1, .ofs_y = -3},
    {.bitmap_index = 541, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 550, .adv_w = 144, .box_w = 4, .box_h = 10, .ofs_x = 2, .ofs_y = 0},
    {.bitmap_index = 555, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 562, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 569, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 576, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 585, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 594, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 601, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 608, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 617, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 624, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 631, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 638, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 645, .adv_w = 144, .box_w = 7, .box_h = 10, .ofs_x = 0, .ofs_y = -3},
    {.bitmap_index = 654, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 0},
    {.bitmap_index = 661, .adv_w = 144, .box_w = 6, .box_h = 10, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 669, .adv_w = 144, .box_w = 2, .box_h = 10, .ofs_x = 3, .ofs_y = 0},
    {.bitmap_index = 672, .adv_w = 144, .box_w = 6, .box_h = 10, .ofs_x = 1, .ofs_y = 0},
    {.bitmap_index = 680, .adv_w = 144, .box_w = 7, .box_h = 2, .ofs_x = 0, .ofs_y = 9},
    {.bitmap_index = 682, .adv_w = 144, .box_w = 7, .box_h = 7, .ofs_x = 0, .ofs_y = 1}
};

/*---------------------
 *  CHARACTER MAPPING
 *--------------------*/



/*Collect the unicode lists and glyph_id offsets*/
static const lv_font_fmt_txt_cmap_t cmaps[] =
{
    {
        .range_start = 32, .range_length = 96, .glyph_id_start = 1,
        .unicode_list = NULL, .glyph_id_ofs_list = NULL, .list_length = 0, .type = LV_FONT_FMT_TXT_CMAP_FORMAT0_TINY
    }
};



/*--------------------
 *  ALL CUSTOM DATA
 *--------------------*/

/*Store all the custom data of the font*/
static lv_font_fmt_txt_dsc_t font_dsc = {
    .glyph_bitmap = gylph_bitmap,
    .glyph_dsc = glyph_dsc,
    .cmaps = cmaps,
    .kern_dsc = NULL,
    .kern_scale = 0,
    .cmap_num = 1,
    .bpp = 1,
    .kern_classes = 0,
    .bitmap_format = 0
};


/*-----------------
 *  PUBLIC FONT
 *----------------*/

/*Initialize a public general font descriptor*/
lv_font_t lv_font_cp437 = {
    .get_glyph_dsc = lv_font_get_glyph_dsc_fmt_txt,    /*Function pointer to get glyph's data*/
    .get_glyph_bitmap = lv_font_get_bitmap_fmt_txt,    /*Function pointer to get glyph's bitmap*/
    .line_height = 15,          /*The maximum line height required by the font*/
    .base_line = 3,             /*Baseline measured from the bottom of the line*/
#if !(LVGL_VERSION_MAJOR == 6 && LVGL_VERSION_MINOR == 0)
    .subpx = LV_FONT_SUBPX_NONE,
#endif
    .dsc = &font_dsc           /*The custom font data. Will be accessed by `get_glyph_bitmap/dsc` */
};

#endif /*#if LV_FONT_CP437*/

