\page Display
\tableofcontents
\brief What is shown on the display.

# Display

## Display type

The Accello has a JHD128128-G02BSW graphical LCD. It's 128x128 pixels. Each pixel supports 4 different grayscale levels.\n
However to keep things simple only 2 colors, black and white, and used in the firmware.

---

## LittlevGL library

The Accello uses the [LittlevGL](https://littlevgl.com/) library to drive the LCD.\n
Currently only images are shown, but the LittlevGL library has support for many different types of [widgets](https://docs.littlevgl.com/en/html/object-types/index.html).

---

## Images

---

### Container locked
|                          |
|--------------------------|
|\image html Locked.png "" |

A deposit is not allowed based on time settings.

---

### Container unlocked
|                             |
|-----------------------------|
| \image html Unlocked.png "" |

The container has been unlocked and a deposit can be done.

---

### Card denied
|                           |
|---------------------------|
| \image html Denied.png "" |

The card is not on the \ref AuthorisationsList.

---

### Success
|                            |
|----------------------------|
| \image html Success.png "" |

The card has been accepted for a deposit.\n
The deposit has succeeded.

---

### Success prepaid
|                                   |
|-----------------------------------|
| \image html SuccessPrepaid.png "" |

The prepaid card has enough credit to do a deposit, and the cost of the deposit
has been written to the card.\n
The credit of the card is shown on the display using a font generator.

---

#### Low credit
|                              |
|------------------------------|
| \image html LowCredit.png "" |

If the credit on the prepaid card is below (CreditWarningLevel * CostInput1)
after the cost of the current deposit has been processed, a warning is shown
on the display and the server is contacted.\n
The credit of the card is shown on the display using a font generator.

---

### Error
|                            |
|----------------------------|
| \image html Error.png ""   |

No deposit detected.

---

### Container full
|                            |
|----------------------------|
| \image html Full.png ""    |

No deposit allowed because the container is full.

---

### Container emptied
|                            |
|----------------------------|
| \image html Empty.png ""   |

Container emptying detected.

---

### Server communication
|                               |
|-------------------------------|
| \image html ServerComm.png "" |

Server communication triggered by \ref CardType_Outbound_Call.

---

#### Insufficient credit
|                                       |
|---------------------------------------|
| \image html InsufficientCredit.png "" |

Prepaid card has insufficient credit to do a deposit.

---

### Status

|                           |
|---------------------------|
| \image html Status.png "" |

```
+----------------+
| 1000162 3.0    |
| B:3.41 E:11.93 |
| C:Y I:1.000    |
| 13:54 R:NA D:N |
| 13:35 R:30 S:Y |
| 12:34 R:27 S:Y |
| 12:17 R:29 S:Y |
+----------------+

<Device ID> <Firmware version>
<B: Internal battery voltage> <E: Solar or external battery voltage>
<C: Y=Charging internal battery, N=Not charging> <I: Charge current>
<Current time>        <R: current modem RSSI> <D: currently contacting server>
<Server contact time> <R: Modem RSSI>         <S: Y=contacted server, N=Could not contact server>
<Server contact - 1>  <R: Modem RSSI>         <S: Y=contacted server, N=Could not contact server>
<Server contact - 2>  <R: Modem RSSI>         <S: Y=contacted server, N=Could not contact server>
```
