\page FactoryReset
\brief When a factory reset is triggered, and what it does.
\tableofcontents

# Accello factory reset

## Triggering the factory reset.

The Accello keeps a counter in a battery backed register, that is incremented
by 2 each time the Accello has booted because of one of the following reasons:

- Power on reset, which can be triggered with a magnet.
- Watchdog timer reset, happens on a freeze or crash.
- Software reboot timer, happens when the Accello stays out of low power mode for too long.

The counter is decremented by 1 each time the Accello has booted because of
another reason, which means it's probably functioning normally as it should.
The counter is never decremented below zero.

When the counter hits 10, a factory reset is triggered. This way if the reset
magnet is used 5 times, or 5 crashes happen in a row, the Accello is reset to
its factory state. This can be used in the field in an emergency, for example
if a lot of Accellos stop functioning correctly because of some data stored in
their flash memory.

## What a factory reset does.

During the factory reset, the LCD backlight blinks to inform that it's in progress.

- All internal flash sectors except the ones holding the bootloader and main
  firmware are erased. This erases all settings.
- The internal RTC and battery backed memory is reset.
- The SPI flash is entirely erased, this erases all log lines, registrations
  and statuses.
- The external RTC is reset.
- The modem is reset to factory defaults using the AT+QPRTPARA=3 command.
- A factory reset status (77) is written.
- The server is contacted to get the current settings, this way the Accello
  will function normally again.

