\page HardwareTest
\brief How to test the Accello pcb.
\tableofcontents

# Testing the Accello pcb

## Charger

The LTC4162EUFD-FADM#TRPBF charger should charge a battery. It will charge a LiFePo battery up to 3.6 volts.\n
If the battery voltage is below 2.5 volts, it will only charge it at 10 mA, this is mainly to bring the battery management out of protect.\n
During a normal charge, the charger will charge the battery at 1A. The charge current is reduced after a while because the charger gets hot.\n

The charger should respond over I2C.

## 4V0 boost converter

The 4V0 boost converter should make 4 volts from the LiFePo battery voltage.

## 5V boost converter.

The 5V boost converter should make 5.5 volts from the LiFePo battery voltage.

## 3.3 volts

The V3.3-UC and V3.3XTRA liness should be 3.3 volts, they are creating using linear regulators connected to 4V0.

## Power consumption

Power consumption from the battery should be around 100 microamps when in sleep mode.

## RFID

The ST25R3911B-AQFT RFID reader should be able to read NFC cards, and bring the microcontroller out of sleep mode.\n
The antenna calibration value should be around 7.

## Flash

SPI flash can be read and written.

## Microcontroller

Firmware can be written using the debug port.\n
Debug text is received over the debug port.\n
JTAG port works.\n
Internal RTC works, keeps its time even if the battery voltage is removed.
Option resistors are placed.

## H-bridges

Can power a servo lock.
Can drive a servo lock.

## Outputs

POWERRAIL_OUT can be switched on and off.\n
PR_OUT1 can be switched on and off.
PR_OUT2 can be switched on and off.

## Buzzer

Beeps at 2730 hertz.

## IO expander

Responds over I2C.\n
TOUCH1 works.\n
TOUCH2 works.\n
TOUCH3 works.\n
IN1 works.\n
IN2 works.\n
IN3 works.\n
IN4 works.\n
Can bring the microcontroller out of sleep mode.

## RS485

Can transmit.\n
Can receive.

## External RTC

Clock runs.\n
Can reset the board on an alarm.\n
Keeps its time even if the battery voltage is removed.

## IrDA

Can send.\n
Can receive.

## Reed switch.

Can reset the microcontroller using a magnet.

## Modem.

Can be turned on and off.\n
Communicates over RS232, with flow control enabled.\n
Can use the internal SIM.\n
Can use the external SIM.\n
Can make a connection to the network.\n
Has good RSSI.\n
Can make a connection to the server.\n
Status led works.\n
NET led works.\n
USB port works.

## GUI

NFC inductor works correctly.\n
LEDs can be turned on and off using the IO expander.\n
LCD works.

## Remarks

Enter remarks here:
