\page InternalFlash
\brief Reserved purposes of flash sectors of the STM32F427 microcontroller.
\tableofcontents

| Block  | Name      | Block addresses           | Size       | Use                       |
|--------|-----------|---------------------------|------------|---------------------------|
| Bank 1 | Sector 0  | 0x0800 0000 - 0x0800 3FFF | 16  Kbytes | Boot firmware             |
| Bank 1 | Sector 1  | 0x0800 4000 - 0x0800 7FFF | 16  Kbytes | Main firmware erased flag |
| Bank 1 | Sector 2  | 0x0800 8000 - 0x0800 BFFF | 16  Kbytes |                           |
| Bank 1 | Sector 3  | 0x0800 C000 - 0x0800 FFFF | 16  Kbytes |                           |
| Bank 1 | Sector 4  | 0x0801 0000 - 0x0801 FFFF | 64  Kbytes |                           |
| Bank 1 | Sector 5  | 0x0802 0000 - 0x0803 FFFF | 128 Kbytes | Main firmware             |
| Bank 1 | Sector 6  | 0x0804 0000 - 0x0805 FFFF | 128 Kbytes | Main firmware             |
| Bank 1 | Sector 7  | 0x0806 0000 - 0x0807 FFFF | 128 Kbytes | Main firmware             |
| Bank 1 | Sector 8  | 0x0808 0000 - 0x0809 FFFF | 128 Kbytes | Main firmware             |
| Bank 1 | Sector 9  | 0x080A 0000 - 0x080B FFFF | 128 Kbytes | Main firmware             |
| Bank 1 | Sector 10 | 0x080C 0000 - 0x080D FFFF | 128 Kbytes | Update firmware           |
| Bank 1 | Sector 11 | 0x080E 0000 - 0x080F FFFF | 128 Kbytes | Update firmware           |
| Bank 2 | Sector 12 | 0x0810 0000 - 0x0810 3FFF | 16  Kbytes | Settings                  |
| Bank 2 | Sector 13 | 0x0810 4000 - 0x0810 7FFF | 16  Kbytes | Settings                  |
| Bank 2 | Sector 14 | 0x0810 8000 - 0x0810 BFFF | 16  Kbytes |                           |
| Bank 2 | Sector 15 | 0x0810 C000 - 0x0810 FFFF | 16  Kbytes |                           |
| Bank 2 | Sector 16 | 0x0811 0000 - 0x0811 FFFF | 64  Kbytes | Images                    |
| Bank 2 | Sector 17 | 0x0812 0000 - 0x0813 FFFF | 128 Kbytes | Authorizations list       |
| Bank 2 | Sector 18 | 0x0814 0000 - 0x0815 FFFF | 128 Kbytes | Authorizations list       |
| Bank 2 | Sector 19 | 0x0816 0000 - 0x0817 FFFF | 128 Kbytes | Authorizations list       |
| Bank 2 | Sector 20 | 0x0818 0000 - 0x0819 FFFF | 128 Kbytes | Authorizations list       |
| Bank 2 | Sector 21 | 0x081A 0000 - 0x081B FFFF | 128 Kbytes | Authorizations list       |
| Bank 2 | Sector 22 | 0x081C 0000 - 0x081D FFFF | 128 Kbytes | Authorizations list       |
| Bank 2 | Sector 23 | 0x081E 0000 - 0x081F FFFF | 128 Kbytes | Authorizations list       |
| System |           | 0x1FFF 0000 - 0x1FFF 77FF | 30  Kbytes |                           |
| OTP    |           | 0x1FFF 7800 - 0x1FFF 7A0F | 528 bytes  |                           |
| Option | Bank 1    | 0x1FFF C000 - 0x1FFF C00F | 16 bytes   |                           |
| Option | Bank 2    | 0x1FFE C000 - 0x1FFE C00F | 16 bytes   |                           |
