\page Registrations
\brief How waste deposits are registered.
\tableofcontents

# Accello registrations

When an NFC card is held against the reader, its UID is read, and based on the authorisations list, an action is performed.\n
After the action is performed, a registration of the UID is stored in the SPI flash.
When the Accello contacts the server, it sends these registrations when it receives a PostRegistrations command in the reply of a GetCommands command.

## Registration object

The Accello stores registrations as a CBOR map in the SPI flash.

    T: UID.
    S: 0 = Deposit opening was opened.
    S: 1 = Deposit opening stayed closed.
    S: 2 = Accello refused to unlock the deposit opening.
    D: Date and time in ISO8661 format of the deposit.
    N: Sequence number of the deposit, used to prove that none were missed.

    {
      "T": "3A81EECE",
      "S": 0,
      "D": "2019-10-25T14:32:08Z",
      "N": 291
    }

## Sequence number

The sequence number N is a number that is kept in the internal flash of the microcontroller.
It is increased by 1 before the action that belongs to a card is executed.
If everything works correctly, every registration sent to the server has a sequence number that is exactly one higher as the previous registration.\n
This can be used to prove that no registration is ever missed.
