#ifndef LTC4162FREGISTERS_H
#define LTC4162FREGISTERS_H

//Defines for registers of the LTC4162-F battery charger.

#define LTC4162F_vbat_lo_alert_limit                                          0x01
#define LTC4162F_vbat_hi_alert_limit                                          0x02
#define LTC4162F_vin_lo_alert_limit                                           0x03
#define LTC4162F_vin_hi_alert_limit                                           0x04
#define LTC4162F_vout_lo_alert_limit                                          0x05
#define LTC4162F_vout_hi_alert_limit                                          0x06
#define LTC4162F_iin_hi_alert_limit                                           0x07
#define LTC4162F_ibat_lo_alert_limit                                          0x08
#define LTC4162F_die_temp_hi_alert_limit                                      0x09
#define LTC4162F_bsr_hi_alert_limit                                           0x0A
#define LTC4162F_thermistor_voltage_hi_alert_limit                            0x0B
#define LTC4162F_thermistor_voltage_lo_alert_limit                            0x0C
#define LTC4162F_EN_LIMIT_ALERTS_REG                                          0x0D
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG                                  0x0E
#define LTC4162F_EN_CHARGE_STATUS_ALERTS_REG                                  0x0F
#define LTC4162F_thermal_reg_start_temp                                       0x10
#define LTC4162F_thermal_reg_end_temp                                         0x11
#define LTC4162F_CONFIG_BITS_REG                                              0x14
#define LTC4162F_iin_limit_target                                             0x15
#define LTC4162F_input_undervoltage_setting                                   0x16
#define LTC4162F_arm_ship_mode                                                0x19
#define LTC4162F_charge_current_setting                                       0x1A
#define LTC4162F_vcharge_setting                                              0x1B
#define LTC4162F_c_over_x_threshold                                           0x1C
#define LTC4162F_max_cv_time                                                  0x1D
#define LTC4162F_max_charge_time                                              0x1E
#define LTC4162F_jeita_t1                                                     0x1F
#define LTC4162F_jeita_t2                                                     0x20
#define LTC4162F_jeita_t3                                                     0x21
#define LTC4162F_jeita_t4                                                     0x22
#define LTC4162F_jeita_t5                                                     0x23
#define LTC4162F_jeita_t6                                                     0x24
#define LTC4162F_VCHARGE_JEITA_6_5_REG                                        0x25
#define LTC4162F_VCHARGE_JEITA_4_3_2_REG                                      0x26
#define LTC4162F_ICHARGE_JEITA_6_5_REG                                        0x27
#define LTC4162F_ICHARGE_JEITA_4_3_2_REG                                      0x28
#define LTC4162F_CHARGER_CONFIG_BITS_REG                                      0x29
#define LTC4162F_vabsorb_delta                                                0x2A
#define LTC4162F_max_absorb_time                                              0x2B
#define LTC4162F_v_recharge_lifepo4                                           0x2E
#define LTC4162F_tchargetimer                                                 0x30
#define LTC4162F_tcvtimer                                                     0x31
#define LTC4162F_tabsorbtimer                                                 0x32
#define LTC4162F_charger_state                                                0x34
#define LTC4162F_charge_status                                                0x35
#define LTC4162F_LIMIT_ALERTS_REG                                             0x36
#define LTC4162F_CHARGER_STATE_ALERTS_REG                                     0x37
#define LTC4162F_CHARGE_STATUS_ALERTS_REG                                     0x38
#define LTC4162F_SYSTEM_STATUS_REG                                            0x39
#define LTC4162F_vbat                                                         0x3A
#define LTC4162F_vin                                                          0x3B
#define LTC4162F_vout                                                         0x3C
#define LTC4162F_ibat                                                         0x3D
#define LTC4162F_iin                                                          0x3E
#define LTC4162F_die_temp                                                     0x3F
#define LTC4162F_thermistor_voltage                                           0x40
#define LTC4162F_bsr                                                          0x41
#define LTC4162F_jeita_region                                                 0x42
#define LTC4162F_CHEM_CELLS_REG                                               0x43
#define LTC4162F_icharge_dac                                                  0x44
#define LTC4162F_vcharge_dac                                                  0x45
#define LTC4162F_iin_limit_dac                                                0x46
#define LTC4162F_vbat_filt                                                    0x47
#define LTC4162F_bsr_charge_current                                           0x48
#define LTC4162F_TELEMETRY_STATUS_REG                                         0x4A
#define LTC4162F_input_undervoltage_dac                                       0x4B

//bits of LTC4162F_EN_LIMIT_ALERTS_REG
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_telemetry_valid_alert                 (1 << 15)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_bsr_done_alert                        (1 << 14)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_vbat_lo_alert                         (1 << 11)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_vbat_hi_alert                         (1 << 10)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_vin_lo_alert                          (1 << 9)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_vin_hi_alert                          (1 << 8)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_vout_lo_alert                         (1 << 7)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_vout_hi_alert                         (1 << 6)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_iin_hi_alert                          (1 << 5)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_ibat_lo_alert                         (1 << 4)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_die_temp_hi_alert                     (1 << 3)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_bsr_hi_alert                          (1 << 2)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_thermistor_voltage_hi_alert           (1 << 1)
#define LTC4162F_EN_LIMIT_ALERTS_REG_en_thermistor_voltage_lo_alert           (1 << 0)

//bits of LTC4162F_EN_CHARGER_STATE_ALERTS_REG
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG_en_bat_detect_failed_fault_alert (1 << 12)
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG_en_battery_detection_alert       (1 << 11)
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG_en_absorb_charge_alert           (1 << 9)
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG_en_charger_suspended_alert       (1 << 8)
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG_en_cc_cv_charge_alert            (1 << 6)
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG_en_ntc_pause_alert               (1 << 5)
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG_en_timer_term_alert              (1 << 4)
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG_en_c_over_x_term_alert           (1 << 3)
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG_en_max_charge_time_alert         (1 << 2)
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG_en_bat_missing_fault_alert       (1 << 1)
#define LTC4162F_EN_CHARGER_STATE_ALERTS_REG_en_bat_short_fault_alert         (1 << 0)

//bits of LTC4162F_EN_CHARGE_STATUS_ALERTS_REG
#define LTC4162F_EN_CHARGE_STATUS_ALERTS_REG_en_ilim_reg_active_alert         (1 << 5)
#define LTC4162F_EN_CHARGE_STATUS_ALERTS_REG_en_thermal_reg_active_alert      (1 << 4)
#define LTC4162F_EN_CHARGE_STATUS_ALERTS_REG_en_vin_uvcl_active_alert         (1 << 3)
#define LTC4162F_EN_CHARGE_STATUS_ALERTS_REG_en_iin_limit_active_alert        (1 << 2)
#define LTC4162F_EN_CHARGE_STATUS_ALERTS_REG_en_constant_current_alert        (1 << 1)
#define LTC4162F_EN_CHARGE_STATUS_ALERTS_REG_en_constant_voltage_alert        (1 << 0)

//bits of LTC4162F_CONFIG_BITS_REG
#define LTC4162F_CONFIG_BITS_REG_suspend_charger                              (1 << 5)
#define LTC4162F_CONFIG_BITS_REG_run_bsr                                      (1 << 4)
#define LTC4162F_CONFIG_BITS_REG_telemetry_speed                              (1 << 3)
#define LTC4162F_CONFIG_BITS_REG_force_telemetry_on                           (1 << 2)
#define LTC4162F_CONFIG_BITS_REG_mppt_en                                      (1 << 1)

//bits of LTC4162F_CHARGER_CONFIG_BITS_REG
#define LTC4162F_CHARGER_CONFIG_BITS_REG_en_c_over_x_term                     (1 << 2)
#define LTC4162F_CHARGER_CONFIG_BITS_REG_en_jeita                             (1 << 0)

//bits of LTC4162F_LIMIT_ALERTS_REG
#define LTC4162F_LIMIT_ALERTS_REG_telemetry_valid_alert                       (1 << 15)
#define LTC4162F_LIMIT_ALERTS_REG_bsr_done_alert                              (1 << 14)
#define LTC4162F_LIMIT_ALERTS_REG_vbat_lo_alert                               (1 << 11)
#define LTC4162F_LIMIT_ALERTS_REG_vbat_hi_alert                               (1 << 10)
#define LTC4162F_LIMIT_ALERTS_REG_vin_lo_alert                                (1 << 9)
#define LTC4162F_LIMIT_ALERTS_REG_vin_hi_alert                                (1 << 8)
#define LTC4162F_LIMIT_ALERTS_REG_vout_lo_alert                               (1 << 7)
#define LTC4162F_LIMIT_ALERTS_REG_vout_hi_alert                               (1 << 6)
#define LTC4162F_LIMIT_ALERTS_REG_iin_hi_alert                                (1 << 5)
#define LTC4162F_LIMIT_ALERTS_REG_ibat_lo_alert                               (1 << 4)
#define LTC4162F_LIMIT_ALERTS_REG_die_temp_hi_alert                           (1 << 3)
#define LTC4162F_LIMIT_ALERTS_REG_bsr_hi_alert                                (1 << 2)
#define LTC4162F_LIMIT_ALERTS_REG_thermistor_voltage_hi_alert                 (1 << 1)
#define LTC4162F_LIMIT_ALERTS_REG_thermistor_voltage_lo_alert                 (1 << 0)

//bits of LTC4162F_CHARGER_STATE_ALERTS_REG
#define LTC4162F_CHARGER_STATE_ALERTS_REG_bat_detect_failed_fault_alert       (1 << 12)
#define LTC4162F_CHARGER_STATE_ALERTS_REG_battery_detection_alert             (1 << 11)
#define LTC4162F_CHARGER_STATE_ALERTS_REG_charger_suspended_alert             (1 << 8)
#define LTC4162F_CHARGER_STATE_ALERTS_REG_cc_cv_charge_alert                  (1 << 6)
#define LTC4162F_CHARGER_STATE_ALERTS_REG_ntc_pause_alert                     (1 << 5)
#define LTC4162F_CHARGER_STATE_ALERTS_REG_timer_term_alert                    (1 << 4)
#define LTC4162F_CHARGER_STATE_ALERTS_REG_c_over_x_term_alert                 (1 << 3)
#define LTC4162F_CHARGER_STATE_ALERTS_REG_max_charge_time_alert               (1 << 2)
#define LTC4162F_CHARGER_STATE_ALERTS_REG_bat_missing_fault_alert             (1 << 1)
#define LTC4162F_CHARGER_STATE_ALERTS_REG_bat_short_fault_alert               (1 << 0)

//bits of LTC4162F_charger_state
#define LTC4162F_charger_state_bat_detect_failed_fault                        (1 << 12)
#define LTC4162F_charger_state_battery_detection                              (1 << 11)
#define LTC4162F_charger_state_absorb_charge                                  (1 << 9)
#define LTC4162F_charger_state_charger_suspended                              (1 << 8)
#define LTC4162F_charger_state_cc_cv_charge                                   (1 << 6)
#define LTC4162F_charger_state_ntc_pause                                      (1 << 5)
#define LTC4162F_charger_state_timer_term                                     (1 << 4)
#define LTC4162F_charger_state_c_over_x_term                                  (1 << 3)
#define LTC4162F_charger_state_max_charge_time_fault                          (1 << 2)
#define LTC4162F_charger_state_bat_missing_fault                              (1 << 1)
#define LTC4162F_charger_state_bat_short_fault                                (1 << 0)

//bits of LTC4162F_CHARGE_STATUS_ALERTS_REG
#define LTC4162F_CHARGE_STATUS_ALERTS_REG_ilim_reg_active_alert               (1 << 5)
#define LTC4162F_CHARGE_STATUS_ALERTS_REG_thermal_reg_active_alert            (1 << 4)
#define LTC4162F_CHARGE_STATUS_ALERTS_REG_vin_uvcl_active_alert               (1 << 3)
#define LTC4162F_CHARGE_STATUS_ALERTS_REG_iin_limit_active_alert              (1 << 2)
#define LTC4162F_CHARGE_STATUS_ALERTS_REG_constant_current_alert              (1 << 1)
#define LTC4162F_CHARGE_STATUS_ALERTS_REG_constant_voltage_alert              (1 << 0)

//bits of LTC4162F_SYSTEM_STATUS_REG
#define LTC4162F_SYSTEM_STATUS_REG_en_chg                                     (1 << 8)
#define LTC4162F_SYSTEM_STATUS_REG_cell_count_err                             (1 << 7)
#define LTC4162F_SYSTEM_STATUS_REG_no_rt                                      (1 << 5)
#define LTC4162F_SYSTEM_STATUS_REG_thermal_shutdown                           (1 << 4)
#define LTC4162F_SYSTEM_STATUS_REG_vin_ovlo                                   (1 << 3)
#define LTC4162F_SYSTEM_STATUS_REG_vin_gt_vbat                                (1 << 2)
#define LTC4162F_SYSTEM_STATUS_REG_vin_gt_4p2v                                (1 << 1)
#define LTC4162F_SYSTEM_STATUS_REG_intvcc_gt_2p8v                             (1 << 0)

//bits of LTC4162F_TELEMETRY_STATUS_REG
#define LTC4162F_TELEMETRY_STATUS_REG_bsr_questionable                        (1 << 1)
#define LTC4162F_TELEMETRY_STATUS_REG_telemetry_valid                         (1 << 0)

//default value of the LTC4162F_max_cv_time register
#define LTC4162F_max_cv_time_default                                          3600

//default value of the LTC4162F_v_recharge_lifepo4 register
#define LTC4162F_v_recharge_lifepo4_default                                   17424

//macro to convert from voltage to a value for the LTC4162F_v_recharge_lifepo4 register
#define LTC4162F_v_recharge_lifepo4_from_volt(v)                              ((uint16_t)((float)(v) / 3.5f * 18191.0f + 0.5f))

//macro to convert from a value for the LTC4162F_v_recharge_lifepo4 register to voltage
#define LTC4162F_v_recharge_lifepo4_to_volt(r)                                ((float)(r) / 18191.0f * 3.5f)

//default value of the LTC4162F_input_undervoltage_setting register
#define LTC4162F_input_undervoltage_setting_default                           31

//macro to convert from a value from the LTC4162F_input_undervoltage_setting register to voltage
#define LTC4162F_input_undervoltage_setting_to_volt(r)                        (((float)(r) + 1.0f) * 0.140625f)

//macro to convert from voltage to a value for the LTC4162F_input_undervoltage_setting register
#define LTC4162F_input_undervoltage_setting_from_volt(v)                      ((uint16_t)((float)(v) / 0.140625f - 0.5f))

//possible values of LTC4162F_CHEM_CELLS_REG
#define LTC4162_LAD                                                           0
#define LTC4162_L42                                                           1
#define LTC4162_L41                                                           2
#define LTC4162_L40                                                           3
#define LTC4162_FAD                                                           4
#define LTC4162_FFS                                                           5
#define LTC4162_FST                                                           6
#define LTC4162_SST                                                           8
#define LTC4162_SAD                                                           9

/*! Converts bits 11:8 of LTC4162F_CHEM_CELLS_REG to a printable string.*/
static inline const char* LTC4162ChemistryStr(uint32_t chemistry)
{
  const char* chemistrystrs[] =
  {
    "LTC4162_LAD",
    "LTC4162_L42",
    "LTC4162_L41",
    "LTC4162_L40",
    "LTC4162_FAD",
    "LTC4162_FFS",
    "LTC4162_FST",
    "LTC4162_SST",
    "LTC4162_SAD"
  };

  if (chemistry < sizeof(chemistrystrs) / sizeof(chemistrystrs[0]))
    return chemistrystrs[chemistry];
  else
    return "UNKNOWN";
}

#endif //LTC4162FREGISTERS_H
