#ifndef APNLIST_H
#define APNLIST_H

#include "apns.h"
#include "inclstdint.h"

class CAPNList
{
  public:
    CAPNList();

    void        Reset();

    const _apn* GetApn(const char* spn, const char* imsi, const char* iccid);
    const char* GetPIN(const char* iccid);

  private:
    const _apn* GetApnFromLocal(const char* iccid);
    const _apn* GetApnFromGlobal(const char* spn, const char* imsi);
    const _apn* GetDefaultApn();
    bool        MatchesMVNO(const _apn* apn, const char* imsi, const char* spn);

    uint32_t    m_localindex;
    uint32_t    m_globalindex;
    uint32_t    m_defaultindex;
};

#endif //APNLIST_H
