#ifndef CRC_H
#define CRC_H

#include <FreeRTOS.h>
#include <semphr.h>

class CCRC32Hw
{
  public:
    CCRC32Hw();
    ~CCRC32Hw();

    static void              EnableClock();

    static void              SetupMutex();
    static uint32_t          Calculate(uint32_t* buf,  uint32_t size);

  private:
    static uint32_t          Generate(uint32_t* buf, uint32_t size);
    static bool              m_enabled;
    static SemaphoreHandle_t m_mutex;
};

#endif //CRC_H
