#ifndef CRYPTOKEYS_H
#define CRYPTOKEYS_H

#include "inclstdint.h"

#define CRYPTO_KEY_SIZE 16

extern const uint8_t  AccelloFwEncryptKey[CRYPTO_KEY_SIZE];              //!< AES key.
extern const uint8_t  AccelloFwSignKey[CRYPTO_KEY_SIZE];                 //!< Signature SHA256 HMAC key.
extern const uint8_t  AccelloFwBlockSignKey[CRYPTO_KEY_SIZE];            //!< Block SHA256 HMAC key.
extern const uint8_t  AccelloFlashRingBufferSignKey[CRYPTO_KEY_SIZE];    //!< Flash ringbuffer SHA256 HMAC key
extern const uint8_t  AccelloFlashRingBufferEncryptKey[CRYPTO_KEY_SIZE]; //!< Flash ringbuffer AES key

extern const uint8_t  EcatFwEncryptKey[CRYPTO_KEY_SIZE];                 //!< AES key.
extern const uint8_t  EcatFwSignKey[CRYPTO_KEY_SIZE];                    //!< Signature SHA256 HMAC key.
extern const uint8_t  EcatFwBlockSignKey[CRYPTO_KEY_SIZE];               //!< Block SHA256 HMAC key.
extern const uint8_t  EcatFlashRingBufferSignKey[CRYPTO_KEY_SIZE];       //!< Flash ringbuffer SHA256 HMAC key
extern const uint8_t  EcatFlashRingBufferEncryptKey[CRYPTO_KEY_SIZE];    //!< Flash ringbuffer AES key
extern const uint8_t  EcatLoRaSignKey[CRYPTO_KEY_SIZE];                  //!< LoRa SHA256 HMAC key.

extern const uint8_t  TMTFwEncryptKey[CRYPTO_KEY_SIZE];                  //!< AES key.
extern const uint8_t  TMTFwSignKey[CRYPTO_KEY_SIZE];                     //!< Signature SHA256 HMAC key.
extern const uint8_t  TMTFwBlockSignKey[CRYPTO_KEY_SIZE];                //!< Block SHA256 HMAC key.
extern const uint8_t  TMTFlashRingBufferSignKey[CRYPTO_KEY_SIZE];        //!< Flash ringbuffer SHA256 HMAC key
extern const uint8_t  TMTFlashRingBufferEncryptKey[CRYPTO_KEY_SIZE];     //!< Flash ringbuffer AES key

extern const uint8_t* FwEncryptKey;
extern const uint8_t* FwSignKey;
extern const uint8_t* FwBlockSignKey;
extern const uint8_t* FlashRingbufferSignKey;
extern const uint8_t* FlashRingbufferEncryptKey;

#endif //CRYPTOKEYS_H
