#ifndef EXTERNALRTC_H
#define EXTERNALRTC_H

#include <stm32f4xx.h>
#include "i2c.h"
#include "gpiopin.h"

/*! Interface class for the PCF8563 RTC.*/
class CExternalRTC
{
  public:
    CExternalRTC();
    void         Setup(CI2C* i2c, SGPIOPin reboothold,
                       bool checkvlow = true, bool forcereset = false);
    bool         Test();
    void         SetupReset();
    bool         ResetRegisters();

  private:
    bool         ReadRegisters(uint8_t reg, uint8_t* buf, uint32_t count);
    bool         WriteRegisters(uint8_t reg, const uint8_t* buf, uint32_t count);

    bool         CheckVlow();
    bool         CheckAlarm();
    bool         PrintRTCTime();

    bool         RTCSeconds(uint8_t* seconds);

    CI2C*        m_i2c;
    SGPIOPin     m_reboothold;
};

#endif //EXTERNALRTC_H
