#ifndef FILLLEVELSENSOR_H
#define FILLLEVELSENSOR_H

#include "usart.h"
#include "inclstdint.h"

#define SENSOR_MSG_SIZE 4

/*! Class that reads data from the A01NYUB fill level sensor,
    and converts its data to meters.*/
class CFillLevelSensor
{
  public:
    CFillLevelSensor();

    void     Setup(USART_TypeDef* usart);
    void     Close();
    bool     Read(uint32_t timeout = 1000);
    float    Distance() { return m_distance; }

  private:
    void     ResetRead();
    bool     ProcessMessage(uint8_t input);

    CUsart   m_usart;
    uint8_t  m_buf[SENSOR_MSG_SIZE];
    uint32_t m_buffill;
    float    m_distance;
};

#endif //FILLLEVELSENSOR_H
