#ifndef GUILEDS_H
#define GUILEDS_H

#include "i2c.h"
#include "ioexpander.h"
#include "orientation.h"

#define GUILED_BOT_LEFT_RED  IOEXP_GP0
#define GUILED_BOT_LEFT_GRN  IOEXP_GP1

#define GUILED_BOT_RIGHT_RED IOEXP_GP2
#define GUILED_BOT_RIGHT_GRN IOEXP_GP3

#define GUILED_TOP_RIGHT_RED IOEXP_GP4
#define GUILED_TOP_RIGHT_GRN IOEXP_GP5

#define GUILED_TOP_LEFT_RED  IOEXP_GP6
#define GUILED_TOP_LEFT_GRN  IOEXP_GP7

#define GUILED_ALL           IOEXP_ALL

#define GUILED_ALL_RED       (GUILED_BOT_LEFT_RED | GUILED_BOT_RIGHT_RED | \
                              GUILED_TOP_RIGHT_RED | GUILED_TOP_LEFT_RED)

#define GUILED_ALL_GRN       (GUILED_BOT_LEFT_GRN | GUILED_BOT_RIGHT_GRN | \
                              GUILED_TOP_RIGHT_GRN | GUILED_TOP_LEFT_GRN)

class CGUILeds
{
  public:
    CGUILeds();
    ~CGUILeds();

    bool         Setup(CI2C* i2c, uint8_t addr, EOrientation orientation = Orientation_Top);
    void         On(uint8_t leds);
    void         Off(uint8_t leds);
    bool         Enabled() { return m_enabled; }

  private:
    uint8_t      Translate(uint8_t leds);

    CI2C*        m_i2c;
    uint8_t      m_addr;
    CIOExpander  m_ioexpander;
    bool         m_enabled;
    EOrientation m_orientation;
};

#endif //GUILEDS_H
