#ifndef INTERNALFLASH_H
#define INTERNALFLASH_H

#include <stm32f4xx.h>
#include "inclstdint.h"

#include <FreeRTOS.h>
#include <semphr.h>

void              InitFlashMutex();
SemaphoreHandle_t FlashMutex();
const char*       FlashStatusStr(FLASH_Status status);
uint16_t          FlashNumToSectorID(uint32_t sectornum);
uint32_t          FlashSectorAddress(uint32_t sectornum);
uint32_t          FlashSectorsSize(uint32_t startsector, uint32_t numsectors);
uint32_t          FlashSectorSize(uint32_t sector);
bool              FlashSectorIsErased(uint32_t sectornum);
bool              FlashEraseSector(uint32_t sectornum);
bool              FlashEraseSectors(uint32_t startsector, uint32_t numsectors);
bool              FlashWrite(uint32_t address, uint8_t* buf, uint32_t numbytes);

#endif //INTERNALFLASH_H
