#ifndef OLEDDISPLAY_H
#define OLEDDISPLAY_H

#include "i2c.h"
#include "inclstdint.h"

#define OLED_DPY_WIDTH      128
#define OLED_DPY_HEIGHT      64
#define OLED_DPY_LINES        8
#define OLED_DPY_CHAR_WIDTH   8
#define OLED_DPY_CHAR_HEIGHT  8
#define OLED_DPY_LINESIZE (OLED_DPY_WIDTH / OLED_DPY_CHAR_WIDTH)

class COLEDDisplay
{
  public:
    COLEDDisplay();
    ~COLEDDisplay();

    bool     Setup(CI2C* i2c);
    bool     Working() { return m_working; }

    void     Clear();
    bool     Draw();
    void     DrawText(const char* text, uint32_t line);

  private:
    bool     FindAddr();
    bool     Init();

    CI2C*    m_i2c;
    bool     m_working;
    uint32_t m_addr;
    uint8_t  m_buf[OLED_DPY_WIDTH * OLED_DPY_HEIGHT / 8];
};

#endif //OLEDDISPLAY_H
