#ifndef OTPADDRS_H
#define OTPADDRS_H

//! The first 32 bits of the OTP memory is used to store the device ID.
#define DEVICE_ID_ADDR1 0x1FFF7800

//! Address to write 0 to to lock OTP data block 0.
#define DEVICE_ID_LOCK_ADDR1 0x1FFF7A00

/*! Secondary OTP memory block that a device ID can be stored in, in case
    the device ID should ever be changed.*/
#define DEVICE_ID_ADDR2 0x1FFF7820

//! Address to write 0 to to lock OTP data block 1.
#define DEVICE_ID_LOCK_ADDR2 0x1FFF7A01

//! Compile time switch to select which device ID to program.
#define DEVICE_ID_PROGRAM_SELECT 1

#if (DEVICE_ID_PROGRAM_SELECT == 1)
  #define DEVICE_ID_PROGRAM      DEVICE_ID_ADDR1
  #define DEVICE_ID_PROGRAM_LOCK DEVICE_ID_LOCK_ADDR1
#elif (DEVICE_ID_PROGRAM_SELECT == 2)
  #define DEVICE_ID_PROGRAM      DEVICE_ID_ADDR2
  #define DEVICE_ID_PROGRAM_LOCK DEVICE_ID_LOCK_ADDR2
#else
  #error DEVICE_ID_PROGRAM_SELECT should be 1 or 2
#endif

// OTP data block 15 is reserved on the Accello for storing the active state.

#endif //OTPADDRS_H
