#ifndef SPIFLASH_S25FL512S_H
#define SPIFLASH_S25FL512S_H

#include "spiflash.h"

class CSPIFlash_S25FL512S : public CSPIFlash
{
  public:
    CSPIFlash_S25FL512S();
    ~CSPIFlash_S25FL512S();

    virtual bool     Erase(uint32_t sector, uint32_t numsectors, bool* isalreayerased = nullptr);
    virtual bool     Read(uint32_t address, uint8_t* buf, uint32_t size);
    virtual bool     Write(uint32_t address, const uint8_t* buf, uint32_t size, bool waitfinish = true);
    virtual int32_t  FindByte(uint32_t address, uint32_t size, uint8_t match, EMatchType matchtype = MatchType_Normal);
    virtual bool     IsErased(uint32_t address, uint32_t size);
    virtual bool     IsSectorErased(uint32_t sector);

    virtual uint32_t Size()       {return 64 * 1024 * 1024;}
    virtual uint32_t SectorSize() {return 256 * 1024;      }
    virtual uint32_t PageSize()   {return 512;             }
    virtual uint32_t ECCSize()    {return 16;              }

  private:
    virtual bool     SetupInternal();
    virtual void     CloseInternal();

    void             EnableWrite();
    bool             WriteInProgress(bool* e_err, bool* p_err);
    bool             WritePage(uint32_t address, const uint8_t* buf, uint32_t size);
    bool             WaitWriteFinished();

};

#endif //SPIFLASH_S25FL512S_H
