#ifndef SPIFLASHADDRS_H
#define SPIFLASHADDRS_H

/*! 3 megabyte at the start of the SPI flash is reserved for the firmware update image.*/
#define FWUPDATE_RESERVED (3 * 1024 * 1024)
#define FWUPDATE_ADDRESS  (0)

/*! 1 megabyte of the firmware update space is used to test if the SPI flash is working.*/
#define TEST_RESERVED     (1024 * 1024)
#define TEST_ADDRESS      (FWUPDATE_ADDRESS)

/*! 1 megabyte of the SPI flash is reserved for the log ringbuffer,
    after the section reserved for firmware updates.*/
#define LOGFLASH_RESERVED (1024 * 1024)
#define LOGFLASH_ADDRESS  (FWUPDATE_ADDRESS + FWUPDATE_RESERVED)

#endif //SPIFLASHADDRS_H
