#include "cryptokeys.h"

const uint8_t AccelloFwEncryptKey[CRYPTO_KEY_SIZE] =
{0xac, 0x3c, 0x08, 0xc9, 0x63, 0x25, 0x2d, 0xa5, 0xb5, 0x22, 0x3f, 0x84, 0x5d, 0x8f, 0x40, 0xd6};

const uint8_t AccelloFwSignKey[CRYPTO_KEY_SIZE] =
{0x41, 0x8c, 0xac, 0x2d, 0xc6, 0x52, 0xf6, 0x26, 0xa5, 0xe8, 0xd7, 0xf6, 0x2b, 0x7f, 0x02, 0x53};

const uint8_t AccelloFwBlockSignKey[CRYPTO_KEY_SIZE] =
{0xc3, 0x37, 0x56, 0x2e, 0xee, 0xd1, 0xc4, 0x1f, 0xdb, 0x67, 0x61, 0x2f, 0xf3, 0xb6, 0x7a, 0xb0};

const uint8_t AccelloFlashRingBufferSignKey[CRYPTO_KEY_SIZE]
{0x19, 0x14, 0x31, 0xe3, 0xa2, 0x4f, 0x16, 0x00, 0x60, 0x95, 0x18, 0xff, 0x3a, 0x93, 0x74, 0x12};

const uint8_t AccelloFlashRingBufferEncryptKey[CRYPTO_KEY_SIZE]
{0x37, 0x42, 0xdf, 0xab, 0xb2, 0x89, 0xa6, 0xda, 0x6b, 0x10, 0x65, 0x1e, 0xf4, 0x97, 0x79, 0x6c};


const uint8_t EcatFwEncryptKey[CRYPTO_KEY_SIZE] =
{0x46, 0xa4, 0x1b, 0x32, 0xa2, 0xef, 0x45, 0xbd, 0xdd, 0xa6, 0x90, 0x07, 0x31, 0x59, 0x6f, 0xb2};

const uint8_t EcatFwSignKey[CRYPTO_KEY_SIZE] =
{0xf2, 0x92, 0x87, 0xb3, 0x12, 0x30, 0x9c, 0xe6, 0x57, 0xdb, 0x0c, 0xe1, 0x1a, 0x01, 0x88, 0x1e};

const uint8_t EcatFwBlockSignKey[CRYPTO_KEY_SIZE] =
{0xf6, 0x4e, 0xe1, 0x9c, 0xe3, 0x35, 0xad, 0x8a, 0xcd, 0xc8, 0xbd, 0xed, 0xc3, 0x96, 0x1a, 0x07};

const uint8_t EcatFlashRingBufferSignKey[CRYPTO_KEY_SIZE] =
{0x00, 0xb3, 0xbb, 0x5c, 0x92, 0x5c, 0x2b, 0x0f, 0x2b, 0x9f, 0x13, 0x55, 0x8c, 0x08, 0xb0, 0xbc};

const uint8_t EcatFlashRingBufferEncryptKey[CRYPTO_KEY_SIZE] =
{0x57, 0x2d, 0x35, 0x2e, 0x72, 0xa0, 0x50, 0x61, 0x14, 0xd6, 0xa8, 0x89, 0x3c, 0xe8, 0xa6, 0xa3};

const uint8_t EcatLoRaSignKey[CRYPTO_KEY_SIZE] =
{0xd1, 0x39, 0x2b, 0x21, 0x8b, 0xfa, 0xab, 0x40, 0x21, 0x50, 0xe7, 0x4e, 0xaf, 0xfe, 0x9a, 0xb1};


const uint8_t TMTFwEncryptKey[CRYPTO_KEY_SIZE] =
{0xa4, 0xa5, 0xc6, 0x3b, 0xa2, 0x21, 0x90, 0xac, 0x2d, 0x6b, 0x78, 0x9d, 0x28, 0xbf, 0x95, 0x80};

const uint8_t TMTFwSignKey[CRYPTO_KEY_SIZE] =
{0x80, 0x1f, 0xbb, 0x7a, 0x20, 0xb1, 0x02, 0x9c, 0xdb, 0xb1, 0x42, 0x09, 0x07, 0x25, 0xf5, 0x32};

const uint8_t TMTFwBlockSignKey[CRYPTO_KEY_SIZE] =
{0x8d, 0x6b, 0xc6, 0xe2, 0xc4, 0xcf, 0x1a, 0xad, 0x09, 0xdd, 0x0d, 0x32, 0xf7, 0x1c, 0x9b, 0x81};

const uint8_t TMTFlashRingBufferSignKey[CRYPTO_KEY_SIZE]
{0xc3, 0x0a, 0x77, 0x8a, 0xc9, 0x4b, 0xd5, 0x6f, 0x2b, 0xc8, 0x00, 0x5d, 0x43, 0x75, 0xe4, 0x0f};

const uint8_t TMTFlashRingBufferEncryptKey[CRYPTO_KEY_SIZE]
{0x8a, 0xb6, 0x85, 0x64, 0x7e, 0x6e, 0xc2, 0x5a, 0xad, 0x2c, 0xff, 0xf3, 0x29, 0x79, 0xe8, 0x1e};

#ifdef ACCELLO 
const uint8_t* FwEncryptKey              = AccelloFwEncryptKey;
const uint8_t* FwSignKey                 = AccelloFwSignKey;
const uint8_t* FwBlockSignKey            = AccelloFwBlockSignKey;
const uint8_t* FlashRingbufferSignKey    = AccelloFlashRingBufferSignKey;
const uint8_t* FlashRingbufferEncryptKey = AccelloFlashRingBufferEncryptKey;
#elif defined(ECAT)
const uint8_t* FwEncryptKey              = EcatFwEncryptKey;
const uint8_t* FwSignKey                 = EcatFwSignKey;
const uint8_t* FwBlockSignKey            = EcatFwBlockSignKey;
const uint8_t* FlashRingbufferSignKey    = EcatFlashRingBufferSignKey;
const uint8_t* FlashRingbufferEncryptKey = EcatFlashRingBufferEncryptKey;
#elif defined(TMT)
const uint8_t* FwEncryptKey              = TMTFwEncryptKey;
const uint8_t* FwSignKey                 = TMTFwSignKey;
const uint8_t* FwBlockSignKey            = TMTFwBlockSignKey;
const uint8_t* FlashRingbufferSignKey    = TMTFlashRingBufferSignKey;
const uint8_t* FlashRingbufferEncryptKey = TMTFlashRingBufferEncryptKey;
#else
const uint8_t* FwEncryptKey              = nullptr;
const uint8_t* FwSignKey                 = nullptr;
const uint8_t* FwBlockSignKey            = nullptr;
const uint8_t* FlashRingbufferSignKey    = nullptr;
const uint8_t* FlashRingbufferEncryptKey = nullptr;
#endif
