#include "orientation.h"
#include "inclstdint.h"

/*! Converts values from EOrientation to a printable string.*/
const char* OrientationStr(EOrientation orientation)
{
  static const char* orientations[] =
  {
    "top",
    "right",
    "bottom",
    "left",
  };

  uint32_t numorientations = sizeof(orientations) / sizeof(orientations[0]);
  if (orientation >= 0 && orientation < numorientations)
    return orientations[orientation];
  else
    return "ERROR UNKNOWN ORIENTATION";
}
