//IRQ handlers declared as weak, they will be overridden by other IRQ handlers
//declared elsewhere.
//The weak definitions in startup_stm32.s should be commented out, because they
//don't work correctly with link time optimization. It's suspected that that is
//because the weak declarations in startup_stm32.s makes all IRQ handlers delared
//in the whole project weak.

void __attribute__((weak)) NMI_Handler() { for(;;); }
void __attribute__((weak)) HardFault_Handler() { for(;;); }
void __attribute__((weak)) MemManage_Handler() { for(;;); }
void __attribute__((weak)) BusFault_Handler() { for(;;); }
void __attribute__((weak)) UsageFault_Handler() { for(;;); }
void __attribute__((weak)) SVC_Handler() { for(;;); }
void __attribute__((weak)) DebugMon_Handler() { for(;;); }
void __attribute__((weak)) PendSV_Handler() { for(;;); }
void __attribute__((weak)) SysTick_Handler() { for(;;); }
void __attribute__((weak)) WWDG_IRQHandler() { for(;;); }              /* Window Watchdog interrupt                                          */
void __attribute__((weak)) PVD_IRQHandler() { for(;;); }               /* PVD through EXTI line detection interrupt                          */
void __attribute__((weak)) TAMP_STAMP_IRQHandler() { for(;;); }        /* Tamper and TimeStamp interrupts through the EXTI line              */
void __attribute__((weak)) RTC_WKUP_IRQHandler() { for(;;); }          /* RTC Wakeup interrupt through the EXTI line                         */
void __attribute__((weak)) FLASH_IRQHandler() { for(;;); }             /* Flash global interrupt                                             */
void __attribute__((weak)) RCC_IRQHandler() { for(;;); }               /* RCC global interrupt                                               */
void __attribute__((weak)) EXTI0_IRQHandler() { for(;;); }             /* EXTI Line0 interrupt                                               */
void __attribute__((weak)) EXTI1_IRQHandler() { for(;;); }             /* EXTI Line1 interrupt                                               */
void __attribute__((weak)) EXTI2_IRQHandler() { for(;;); }             /* EXTI Line2 interrupt                                               */
void __attribute__((weak)) EXTI3_IRQHandler() { for(;;); }             /* EXTI Line3 interrupt                                               */
void __attribute__((weak)) EXTI4_IRQHandler() { for(;;); }             /* EXTI Line4 interrupt                                               */
//void __attribute__((weak)) DMA1_Stream0_IRQHandler() { for(;;); }      /* DMA1 Stream0 global interrupt                                      */
//void __attribute__((weak)) DMA1_Stream1_IRQHandler() { for(;;); }      /* DMA1 Stream1 global interrupt                                      */
//void __attribute__((weak)) DMA1_Stream2_IRQHandler() { for(;;); }      /* DMA1 Stream2 global interrupt                                      */
//void __attribute__((weak)) DMA1_Stream3_IRQHandler() { for(;;); }      /* DMA1 Stream3 global interrupt                                      */
//void __attribute__((weak)) DMA1_Stream4_IRQHandler() { for(;;); }      /* DMA1 Stream4 global interrupt                                      */
//void __attribute__((weak)) DMA1_Stream5_IRQHandler() { for(;;); }      /* DMA1 Stream5 global interrupt                                      */
//void __attribute__((weak)) DMA1_Stream6_IRQHandler() { for(;;); }      /* DMA1 Stream6 global interrupt                                      */
void __attribute__((weak)) ADC_IRQHandler() { for(;;); }               /* ADC2 global interrupts                                             */
void __attribute__((weak)) CAN1_TX_IRQHandler() { for(;;); }           /* CAN1 TX interrupts                                                 */
void __attribute__((weak)) CAN1_RX0_IRQHandler() { for(;;); }          /* CAN1 RX0 interrupts                                                */
void __attribute__((weak)) CAN1_RX1_IRQHandler() { for(;;); }          /* CAN1 RX1 interrupts                                                */
void __attribute__((weak)) CAN1_SCE_IRQHandler() { for(;;); }          /* CAN1 SCE interrupt                                                 */
void __attribute__((weak)) EXTI9_5_IRQHandler() { for(;;); }           /* EXTI Line[9:5] interrupts                                          */
void __attribute__((weak)) TIM1_BRK_TIM9_IRQHandler() { for(;;); }     /* TIM1 Break interrupt and TIM9 global interrupt                     */
void __attribute__((weak)) TIM1_UP_TIM10_IRQHandler() { for(;;); }     /* TIM1 Update interrupt and TIM10 global interrupt                   */
void __attribute__((weak)) TIM1_TRG_COM_TIM11_IRQHandler() { for(;;); }/* TIM1 Trigger and Commutation interrupts and TIM11 global interrupt */
void __attribute__((weak)) TIM1_CC_IRQHandler() { for(;;); }           /* TIM1 Capture Compare interrupt                                     */
void __attribute__((weak)) TIM2_IRQHandler() { for(;;); }              /* TIM2 global interrupt                                              */
void __attribute__((weak)) TIM3_IRQHandler() { for(;;); }              /* TIM3 global interrupt                                              */
void __attribute__((weak)) TIM4_IRQHandler() { for(;;); }              /* TIM4 global interrupt                                              */
void __attribute__((weak)) I2C1_EV_IRQHandler() { for(;;); }           /* I2C1 event interrupt                                               */
void __attribute__((weak)) I2C1_ER_IRQHandler() { for(;;); }           /* I2C1 error interrupt                                               */
void __attribute__((weak)) I2C2_EV_IRQHandler() { for(;;); }           /* I2C2 event interrupt                                               */
void __attribute__((weak)) I2C2_ER_IRQHandler() { for(;;); }           /* I2C2 error interrupt                                               */
void __attribute__((weak)) SPI1_IRQHandler() { for(;;); }              /* SPI1 global interrupt                                              */
void __attribute__((weak)) SPI2_IRQHandler() { for(;;); }              /* SPI2 global interrupt                                              */
void __attribute__((weak)) USART1_IRQHandler() { for(;;); }            /* USART1 global interrupt                                            */
void __attribute__((weak)) USART2_IRQHandler() { for(;;); }            /* USART2 global interrupt                                            */
void __attribute__((weak)) USART3_IRQHandler() { for(;;); }            /* USART3 global interrupt                                            */
void __attribute__((weak)) EXTI15_10_IRQHandler() { for(;;); }         /* EXTI Line[15:10] interrupts                                        */
void __attribute__((weak)) RTC_Alarm_IRQHandler() { for(;;); }         /* RTC Alarms (A and B) through EXTI line interrupt                   */
void __attribute__((weak)) OTG_FS_WKUP_IRQHandler() { for(;;); }       /* USB On-The-Go FS Wakeup through EXTI line interrupt                */
void __attribute__((weak)) TIM8_BRK_TIM12_IRQHandler() { for(;;); }    /* TIM8 Break interrupt and TIM12 global interrupt                    */
void __attribute__((weak)) TIM8_UP_TIM13_IRQHandler() { for(;;); }     /* TIM8 Update interrupt and TIM13 global interrupt                   */
void __attribute__((weak)) TIM8_TRG_COM_TIM14_IRQHandler() { for(;;); }/* TIM8 Trigger and Commutation interrupts and TIM14 global interrupt */
void __attribute__((weak)) TIM8_CC_IRQHandler() { for(;;); }           /* TIM8 Capture Compare interrupt                                     */
//void __attribute__((weak)) DMA1_Stream7_IRQHandler() { for(;;); }      /* DMA1 Stream7 global interrupt                                      */
void __attribute__((weak)) FMC_IRQHandler() { for(;;); }               /* FMC global interrupt                                               */
void __attribute__((weak)) SDIO_IRQHandler() { for(;;); }              /* SDIO global interrupt                                              */
void __attribute__((weak)) TIM5_IRQHandler() { for(;;); }              /* TIM5 global interrupt                                              */
void __attribute__((weak)) SPI3_IRQHandler() { for(;;); }              /* SPI3 global interrupt                                              */
void __attribute__((weak)) UART4_IRQHandler() { for(;;); }             /* UART4 global interrupt                                             */
void __attribute__((weak)) UART5_IRQHandler() { for(;;); }             /* UART5 global interrupt                                             */
void __attribute__((weak)) TIM6_DAC_IRQHandler() { for(;;); }          /* TIM6 global interrupt, DAC1 and DAC2 underrun error interrupt      */
void __attribute__((weak)) TIM7_IRQHandler() { for(;;); }              /* TIM7 global interrupt                                              */
//void __attribute__((weak)) DMA2_Stream0_IRQHandler() { for(;;); }      /* DMA2 Stream0 global interrupt                                      */
//void __attribute__((weak)) DMA2_Stream1_IRQHandler() { for(;;); }      /* DMA2 Stream1 global interrupt                                      */
//void __attribute__((weak)) DMA2_Stream2_IRQHandler() { for(;;); }      /* DMA2 Stream2 global interrupt                                      */
//void __attribute__((weak)) DMA2_Stream3_IRQHandler() { for(;;); }      /* DMA2 Stream3 global interrupt                                      */
//void __attribute__((weak)) DMA2_Stream4_IRQHandler() { for(;;); }      /* DMA2 Stream4 global interrupt                                      */
void __attribute__((weak)) ETH_IRQHandler() { for(;;); }               /* Ethernet global interrupt                                          */
void __attribute__((weak)) ETH_WKUP_IRQHandler() { for(;;); }          /* Ethernet Wakeup through EXTI line interrupt                        */
void __attribute__((weak)) CAN2_TX_IRQHandler() { for(;;); }           /* CAN2 TX interrupts                                                 */
void __attribute__((weak)) CAN2_RX0_IRQHandler() { for(;;); }          /* CAN2 RX0 interrupts                                                */
void __attribute__((weak)) CAN2_RX1_IRQHandler() { for(;;); }          /* CAN2 RX1 interrupts                                                */
void __attribute__((weak)) CAN2_SCE_IRQHandler() { for(;;); }          /* CAN2 SCE interrupt                                                 */
void __attribute__((weak)) OTG_FS_IRQHandler() { for(;;); }            /* USB On The Go FS global interrupt                                  */
//void __attribute__((weak)) DMA2_Stream5_IRQHandler() { for(;;); }      /* DMA2 Stream5 global interrupt                                      */
//void __attribute__((weak)) DMA2_Stream6_IRQHandler() { for(;;); }      /* DMA2 Stream6 global interrupt                                      */
//void __attribute__((weak)) DMA2_Stream7_IRQHandler() { for(;;); }      /* DMA2 Stream7 global interrupt                                      */
void __attribute__((weak)) USART6_IRQHandler() { for(;;); }            /* USART6 global interrupt                                            */
void __attribute__((weak)) I2C3_EV_IRQHandler() { for(;;); }           /* I2C3 event interrupt                                               */
void __attribute__((weak)) I2C3_ER_IRQHandler() { for(;;); }           /* I2C3 error interrupt                                               */
void __attribute__((weak)) OTG_HS_EP1_OUT_IRQHandler() { for(;;); }    /* USB On The Go HS End Point 1 Out global interrupt                  */
void __attribute__((weak)) OTG_HS_EP1_IN_IRQHandler() { for(;;); }     /* USB On The Go HS End Point 1 In global interrupt                   */
void __attribute__((weak)) OTG_HS_WKUP_IRQHandler() { for(;;); }       /* USB On The Go HS Wakeup through EXTI interrupt                     */
void __attribute__((weak)) OTG_HS_IRQHandler() { for(;;); }            /* USB On The Go HS global interrupt                                  */
void __attribute__((weak)) DCMI_IRQHandler() { for(;;); }              /* DCMI global interrupt                                              */
void __attribute__((weak)) CRYP_IRQHandler() { for(;;); }              /* CRYP crypto global interrupt                                       */
void __attribute__((weak)) HASH_RNG_IRQHandler() { for(;;); }          /* Hash and Rng global interrupt                                      */
void __attribute__((weak)) FPU_IRQHandler() { for(;;); }               /* Floating point interrupt                                           */
void __attribute__((weak)) UART7_IRQHandler() { for(;;); }             /* UART 7 global interrupt                                            */
void __attribute__((weak)) UART8_IRQHandler() { for(;;); }             /* UART 8 global interrupt                                            */
void __attribute__((weak)) SPI4_IRQHandler() { for(;;); }              /* SPI 4 global interrupt                                             */
void __attribute__((weak)) SPI5_IRQHandler() { for(;;); }              /* SPI 5 global interrupt                                             */
void __attribute__((weak)) SPI6_IRQHandler() { for(;;); }              /* SPI 6 global interrupt                                             */
void __attribute__((weak)) SAI1_IRQHandler() { for(;;); }              /* SAI1 global interrupt                                              */
void __attribute__((weak)) LCD_TFT_IRQHandler() { for(;;); }           /* LTDC global interrupt                                              */
void __attribute__((weak)) LCD_TFT_1_IRQHandler() { for(;;); }         /* LTDC global error interrupt                                        */
void __attribute__((weak)) DMA2D_IRQHandler() { for(;;); }             /* DMA2D global interrupt                                             */

